/*----- PROTECTED REGION ID(Eurotherm2408.cpp) ENABLED START -----*/
static const char *RcsId = "$Id:  $";
//=============================================================================
//
// file :        Eurotherm2408.cpp
//
// description : C++ source for the Eurotherm2408 and its commands.
//               The class is derived from Device. It represents the
//               CORBA servant object which will be accessed from the
//               network. All commands which can be executed on the
//               Eurotherm2408 are implemented in this file.
//
// project :     Eurotherm2408.
//
// $Author:  $
//
// $Revision:  $
// $Date:  $
//
// SVN only:
// $HeadURL:  $
//
// CVS only:
// $Source:  $
// $Log:  $
//
//=============================================================================
//                This file is generated by POGO
//        (Program Obviously used to Generate tango Object)
//=============================================================================


#include <tango.h>
#include <Eurotherm2408.h>
#include <Eurotherm2408Class.h>

extern "C"
{
	#include <sys/stat.h>
    #include <sys/types.h>
	#include <dirent.h>
	#include <sys/stat.h>
    #include <unistd.h>
}
/*----- PROTECTED REGION END -----*/


/**
 *	Eurotherm2408 class description:
 *	
 */

//================================================================
//
//  The following table gives the correspondence
//  between command and method names.
//
//  Command name   |  Method name
//----------------------------------------------------------------
//  State          |  Inherited (no method)
//  Status         |  Inherited (no method)
//  StartProgram   |  start_program
//  StopProgram    |  stop_program
//  HoldProgram    |  hold_program
//  LoadProgram    |  load_program
//  DeleteProgram  |  delete_program
//================================================================

namespace Eurotherm2408_ns
{
	/*----- PROTECTED REGION ID(Eurotherm2408::namespace_starting) ENABLED START -----*/

	//	static initializations

	/*----- PROTECTED REGION END -----*/	//	Eurotherm2408::namespace_starting



//--------------------------------------------------------
/**
 *	Method      : Eurotherm2408::Eurotherm2408()
 *	Description : Constructors for a Tango device
 *	              implementing the class Eurotherm2408
 */
//--------------------------------------------------------
Eurotherm2408::Eurotherm2408(Tango::DeviceClass *cl, string &s)
 	: Tango::Device_4Impl(cl, s.c_str())
{
	/*----- PROTECTED REGION ID(Eurotherm2408::constructor_1) ENABLED START -----*/

	init_device();

	/*----- PROTECTED REGION END -----*/	//	Eurotherm2408::constructor_1
}
//--------------------------------------------------------
Eurotherm2408::Eurotherm2408(Tango::DeviceClass *cl, const char *s)
 	: Tango::Device_4Impl(cl, s)
{
	/*----- PROTECTED REGION ID(Eurotherm2408::constructor_2) ENABLED START -----*/

	init_device();

	/*----- PROTECTED REGION END -----*/	//	Eurotherm2408::constructor_2
}
//--------------------------------------------------------
Eurotherm2408::Eurotherm2408(Tango::DeviceClass *cl, const char *s, const char *d)
 	: Tango::Device_4Impl(cl, s, d)
{
	/*----- PROTECTED REGION ID(Eurotherm2408::constructor_3) ENABLED START -----*/

	init_device();

	/*----- PROTECTED REGION END -----*/	//	Eurotherm2408::constructor_3
}


//--------------------------------------------------------
/**
 *	Method      : Eurotherm2408::delete_device()()
 *	Description : will be called at device destruction or at init command
 */
//--------------------------------------------------------
void Eurotherm2408::delete_device()
{
	/*----- PROTECTED REGION ID(Eurotherm2408::delete_device) ENABLED START -----*/

	//	Delete device allocated objects
	if(!simulationMode)
	{
		delete	eutherm;
	}
	/*----- PROTECTED REGION END -----*/	//	Eurotherm2408::delete_device
	delete[] attr_Temperature_read;
	delete[] attr_Setpoint_read;
	delete[] attr_Manual_read;
	delete[] attr_ProgramState_read;
	delete[] attr_CurrentProgram_read;
	delete[] attr_CurrentSegment_read;
	delete[] attr_RemainingProgramTime_read;
	delete[] attr_RemainingSegmentTime_read;
	delete[] attr_SegmentType_read;
	delete[] attr_ProgramDir_read;
	delete[] attr_MaxPrograms_read;
	delete[] attr_AllowedStates_read;
	delete[] attr_HoldBack_read;
	delete[] attr_OutputLevel_read;
	delete[] attr_OutputLevelMax_read;
	delete[] attr_OutputLevelMin_read;
	
}


//--------------------------------------------------------
/**
 *	Method      : Eurotherm2408::init_device()
 *	Description : //	will be called at device initialization.
 */
//--------------------------------------------------------
void Eurotherm2408::init_device()
{
	DEBUG_STREAM << "Eurotherm2408::init_device() create device " << device_name << endl;

	/*----- PROTECTED REGION ID(Eurotherm2408::init_device_before) ENABLED START -----*/

	//	Initialization before get_device_property() call
	

	/*----- PROTECTED REGION END -----*/	//	Eurotherm2408::init_device_before
	
	//	Get the device properties (if any) from database
	get_device_property();
	
	attr_Temperature_read = new Tango::DevDouble[1];
	attr_Setpoint_read = new Tango::DevDouble[1];
	attr_Manual_read = new Tango::DevBoolean[1];
	attr_ProgramState_read = new Tango::DevString[1];
	attr_CurrentProgram_read = new Tango::DevUShort[1];
	attr_CurrentSegment_read = new Tango::DevUShort[1];
	attr_RemainingProgramTime_read = new Tango::DevUShort[1];
	attr_RemainingSegmentTime_read = new Tango::DevUShort[1];
	attr_SegmentType_read = new Tango::DevString[1];
	attr_ProgramDir_read = new Tango::DevString[1];
	attr_MaxPrograms_read = new Tango::DevUShort[1];
	attr_AllowedStates_read = new Tango::DevUChar[1];
	attr_HoldBack_read = new Tango::DevBoolean[1];
	attr_OutputLevel_read = new Tango::DevDouble[1];
	attr_OutputLevelMax_read = new Tango::DevDouble[1];
	attr_OutputLevelMin_read = new Tango::DevDouble[1];
	
	/*----- PROTECTED REGION ID(Eurotherm2408::init_device) ENABLED START -----*/

	//	Initialize device
	if(!simulationMode && get_state() != Tango::FAULT)
	{
		tty_debug = isatty(0) ? true : false;
		try
		{
			if(connectType == "net")
			{
				eutherm = new Eurotherm2408ctrl(deviceAddress, logicOps, new TcpSocket(hostName.c_str(), portNumber.c_str()));
			}
			else if(connectType == "serial")
			{
				eutherm = new Eurotherm2408ctrl(deviceAddress, logicOps, new TtyDevice(deviceFile.c_str(), baudRate));
			}
			eutherm->consoleDebug(tty_debug);
			eutherm->atomicIO(true);
			eutherm->readTimeout(1,0);
			eutherm->writeTimeout(1,0);
			eutherm->init();
		}
		catch(IpcException& e)
		{
			if(tty_debug) e.IPC_PRINTEX;
			set_state(Tango::FAULT);
			set_status(e.what());
			return;
		}
	}
	else
	{
		*attr_Manual_read = false;
		cerr << "Running in simulation mode\n";
	}
	set_state(Tango::ON);
	*attr_ProgramDir_read = 0;
	*attr_AllowedStates_read = (Eurotherm2408ctrl::ALARM1 | Eurotherm2408ctrl::MANUAL);
	*attr_HoldBack_read = true;

	/*----- PROTECTED REGION END -----*/	//	Eurotherm2408::init_device
}



//--------------------------------------------------------
/**
 *	Method      : Eurotherm2408::get_device_property()
 *	Description : //	Add your own code to initialize
 */
//--------------------------------------------------------
void Eurotherm2408::get_device_property()
{
	/*----- PROTECTED REGION ID(Eurotherm2408::get_device_property_before) ENABLED START -----*/

	//	Initialize property data members
	

	/*----- PROTECTED REGION END -----*/	//	Eurotherm2408::get_device_property_before


	//	Read device properties from database.
	Tango::DbData	dev_prop;
	dev_prop.push_back(Tango::DbDatum("HostName"));
	dev_prop.push_back(Tango::DbDatum("PortNumber"));
	dev_prop.push_back(Tango::DbDatum("DeviceAddress"));
	dev_prop.push_back(Tango::DbDatum("SimulationMode"));
	dev_prop.push_back(Tango::DbDatum("LogicOps"));
	dev_prop.push_back(Tango::DbDatum("ConnectType"));
	dev_prop.push_back(Tango::DbDatum("DeviceFile"));
	dev_prop.push_back(Tango::DbDatum("BaudRate"));

	//	is there at least one property to be read ?
	if (dev_prop.size()>0)
	{
		//	Call database and extract values
		if (Tango::Util::instance()->_UseDb==true)
			get_db_device()->get_property(dev_prop);
	
		//	get instance on Eurotherm2408Class to get class property
		Tango::DbDatum	def_prop, cl_prop;
		Eurotherm2408Class	*ds_class =
			(static_cast<Eurotherm2408Class *>(get_device_class()));
		int	i = -1;

		//	Try to initialize HostName from class property
		cl_prop = ds_class->get_class_property(dev_prop[++i].name);
		if (cl_prop.is_empty()==false)	cl_prop  >>  hostName;
		else {
			//	Try to initialize HostName from default device value
			def_prop = ds_class->get_default_device_property(dev_prop[i].name);
			if (def_prop.is_empty()==false)	def_prop  >>  hostName;
		}
		//	And try to extract HostName value from database
		if (dev_prop[i].is_empty()==false)	dev_prop[i]  >>  hostName;

		//	Try to initialize PortNumber from class property
		cl_prop = ds_class->get_class_property(dev_prop[++i].name);
		if (cl_prop.is_empty()==false)	cl_prop  >>  portNumber;
		else {
			//	Try to initialize PortNumber from default device value
			def_prop = ds_class->get_default_device_property(dev_prop[i].name);
			if (def_prop.is_empty()==false)	def_prop  >>  portNumber;
		}
		//	And try to extract PortNumber value from database
		if (dev_prop[i].is_empty()==false)	dev_prop[i]  >>  portNumber;

		//	Try to initialize DeviceAddress from class property
		cl_prop = ds_class->get_class_property(dev_prop[++i].name);
		if (cl_prop.is_empty()==false)	cl_prop  >>  deviceAddress;
		else {
			//	Try to initialize DeviceAddress from default device value
			def_prop = ds_class->get_default_device_property(dev_prop[i].name);
			if (def_prop.is_empty()==false)	def_prop  >>  deviceAddress;
		}
		//	And try to extract DeviceAddress value from database
		if (dev_prop[i].is_empty()==false)	dev_prop[i]  >>  deviceAddress;

		//	Try to initialize SimulationMode from class property
		cl_prop = ds_class->get_class_property(dev_prop[++i].name);
		if (cl_prop.is_empty()==false)	cl_prop  >>  simulationMode;
		else {
			//	Try to initialize SimulationMode from default device value
			def_prop = ds_class->get_default_device_property(dev_prop[i].name);
			if (def_prop.is_empty()==false)	def_prop  >>  simulationMode;
		}
		//	And try to extract SimulationMode value from database
		if (dev_prop[i].is_empty()==false)	dev_prop[i]  >>  simulationMode;

		//	Try to initialize LogicOps from class property
		cl_prop = ds_class->get_class_property(dev_prop[++i].name);
		if (cl_prop.is_empty()==false)	cl_prop  >>  logicOps;
		else {
			//	Try to initialize LogicOps from default device value
			def_prop = ds_class->get_default_device_property(dev_prop[i].name);
			if (def_prop.is_empty()==false)	def_prop  >>  logicOps;
		}
		//	And try to extract LogicOps value from database
		if (dev_prop[i].is_empty()==false)	dev_prop[i]  >>  logicOps;

		//	Try to initialize ConnectType from class property
		cl_prop = ds_class->get_class_property(dev_prop[++i].name);
		if (cl_prop.is_empty()==false)	cl_prop  >>  connectType;
		else {
			//	Try to initialize ConnectType from default device value
			def_prop = ds_class->get_default_device_property(dev_prop[i].name);
			if (def_prop.is_empty()==false)	def_prop  >>  connectType;
		}
		//	And try to extract ConnectType value from database
		if (dev_prop[i].is_empty()==false)	dev_prop[i]  >>  connectType;

		//	Try to initialize DeviceFile from class property
		cl_prop = ds_class->get_class_property(dev_prop[++i].name);
		if (cl_prop.is_empty()==false)	cl_prop  >>  deviceFile;
		else {
			//	Try to initialize DeviceFile from default device value
			def_prop = ds_class->get_default_device_property(dev_prop[i].name);
			if (def_prop.is_empty()==false)	def_prop  >>  deviceFile;
		}
		//	And try to extract DeviceFile value from database
		if (dev_prop[i].is_empty()==false)	dev_prop[i]  >>  deviceFile;

		//	Try to initialize BaudRate from class property
		cl_prop = ds_class->get_class_property(dev_prop[++i].name);
		if (cl_prop.is_empty()==false)	cl_prop  >>  baudRate;
		else {
			//	Try to initialize BaudRate from default device value
			def_prop = ds_class->get_default_device_property(dev_prop[i].name);
			if (def_prop.is_empty()==false)	def_prop  >>  baudRate;
		}
		//	And try to extract BaudRate value from database
		if (dev_prop[i].is_empty()==false)	dev_prop[i]  >>  baudRate;


	}
	/*----- PROTECTED REGION ID(Eurotherm2408::get_device_property_after) ENABLED START -----*/

	//	Check device property data members init
	if(connectType.size() == 0)
	{
		set_status("Property ConnectType not set");
		set_state(Tango::FAULT);
		return;
	}
	if(connectType != "serial" && connectType != "net")
	{
		set_status("Invalid value for property ConnectType");
		set_state(Tango::FAULT);
		return;
	}
	if(connectType == "serial")
	{
		if(deviceFile.size() == 0)
		{
			set_status("Property DeviceFile not set");
			set_state(Tango::FAULT);
			return;
		}
		if(baudRate == 0)
		{
			set_status("Property BaudRate not set");
			set_state(Tango::FAULT);
			return;
		}
	}
	else if(connectType == "net")
	{
		if(hostName.size() == 0)
		{
			set_status("Property HostName not set");
			set_state(Tango::FAULT);
			return;
		}
		if(portNumber.size() == 0)
		{
			set_status("Property PortNumber not set");
			set_state(Tango::FAULT);
			return;
		}
	}

	/*----- PROTECTED REGION END -----*/	//	Eurotherm2408::get_device_property_after

}

//--------------------------------------------------------
/**
 *	Method      : Eurotherm2408::always_executed_hook()
 *	Description : method always executed before any command is executed
 */
//--------------------------------------------------------
void Eurotherm2408::always_executed_hook()
{
	INFO_STREAM << "Eurotherm2408::always_executed_hook()  " << device_name << endl;
	/*----- PROTECTED REGION ID(Eurotherm2408::always_executed_hook) ENABLED START -----*/

	//	code always executed before all requests
	

	/*----- PROTECTED REGION END -----*/	//	Eurotherm2408::always_executed_hook
}



//--------------------------------------------------------
/**
 *	Method      : Eurotherm2408::read_attr_hardware()
 *	Description : Hardware acquisition for attributes.
 */
//--------------------------------------------------------
void Eurotherm2408::read_attr_hardware(vector<long> &attr_list)
{
	DEBUG_STREAM << "Eurotherm2408::read_attr_hardware(vector<long> &attr_list) entering... " << endl;
	/*----- PROTECTED REGION ID(Eurotherm2408::read_attr_hardware) ENABLED START -----*/

	//	Add your own code
	//	Add your own code here

	/*----- PROTECTED REGION END -----*/	//	Eurotherm2408::read_attr_hardware

}


//--------------------------------------------------------
/**
 *	Read Temperature attribute
 *	Description: The current temperature
 *
 *	Data type:	Tango::DevDouble
 *	Attr type:	Scalar 
 */
//--------------------------------------------------------
void Eurotherm2408::read_Temperature(Tango::Attribute &attr)
{
	DEBUG_STREAM << "Eurotherm2408::read_Temperature(Tango::Attribute &attr) entering... " << endl;
	/*----- PROTECTED REGION ID(Eurotherm2408::read_Temperature) ENABLED START -----*/
	//	Add your own code here
	if(!simulationMode)
	{
		string str;
		try
		{
			if(!eutherm->status(str, *attr_AllowedStates_read))
			{
				set_state(Tango::ALARM);
				set_status(str);
			}
			eutherm->temperature(attr_Temperature_read);
		}
		catch(IpcException& e)
		{
			Tango::Except::throw_exception ("Read error",
				    e.what(), 
				    "Eurotherm2408::read_Temperature",
					Tango::WARN);
		}
	}
	else
	{
		*attr_Temperature_read = *attr_Setpoint_read;
	}
	attr.set_value(attr_Temperature_read);

	/*----- PROTECTED REGION END -----*/	//	Eurotherm2408::read_Temperature
}
//--------------------------------------------------------
/**
 *	Read Setpoint attribute
 *	Description: The current temperature setpoint
 *
 *	Data type:	Tango::DevDouble
 *	Attr type:	Scalar 
 */
//--------------------------------------------------------
void Eurotherm2408::read_Setpoint(Tango::Attribute &attr)
{
	DEBUG_STREAM << "Eurotherm2408::read_Setpoint(Tango::Attribute &attr) entering... " << endl;
	/*----- PROTECTED REGION ID(Eurotherm2408::read_Setpoint) ENABLED START -----*/
	//	Add your own code here
	if(!simulationMode)
	{
		string str;
		try
		{
			if(!eutherm->status(str, *attr_AllowedStates_read))
			{
				set_state(Tango::ALARM);
				set_status(str);
			}
			eutherm->setPoint(attr_Setpoint_read);
		}
		catch(IpcException& e)
		{
			Tango::Except::throw_exception ("Read error",
				    e.what(), 
				    "Eurotherm2408::read_Setpoint",
					Tango::WARN);
		}
	}
	attr.set_value(attr_Setpoint_read);

	/*----- PROTECTED REGION END -----*/	//	Eurotherm2408::read_Setpoint
}

//--------------------------------------------------------
/**
 *	Write Setpoint attribute values to hardware.
 *
 *	Data type:	Tango::DevDouble
 *	Attr type:	Scalar 
 */
//--------------------------------------------------------
void Eurotherm2408::write_Setpoint(Tango::WAttribute &attr)
{
	DEBUG_STREAM << "Eurotherm2408::write_Setpoint(Tango::Attribute &attr) entering... " << endl;
	
	//	Retrieve write value
	Tango::DevDouble	w_val;
	attr.get_write_value(w_val);
	
	/*----- PROTECTED REGION ID(Eurotherm2408::write_Setpoint) ENABLED START -----*/
	//	Add your own code here	
	if(!simulationMode)
	{
		string str;
		try
		{
			if(!eutherm->status(str, *attr_AllowedStates_read))
			{
				set_state(Tango::ALARM);
				set_status(str);
			}
			eutherm->setPoint(w_val);
		}
		catch(IpcException& e)
		{
			Tango::Except::throw_exception ("Write error",
				    e.what(), 
				    "Eurotherm2408::write_Setpoint",
					Tango::WARN);
		}
	}
	else
	{
		*attr_Setpoint_read = w_val;
	}

	/*----- PROTECTED REGION END -----*/	//	Eurotherm2408::write_Setpoint
}

//--------------------------------------------------------
/**
 *	Read Manual attribute
 *	Description: Manual mode (true = on, false = off)
 *
 *	Data type:	Tango::DevBoolean
 *	Attr type:	Scalar 
 */
//--------------------------------------------------------
void Eurotherm2408::read_Manual(Tango::Attribute &attr)
{
	DEBUG_STREAM << "Eurotherm2408::read_Manual(Tango::Attribute &attr) entering... " << endl;
	/*----- PROTECTED REGION ID(Eurotherm2408::read_Manual) ENABLED START -----*/
	if(!simulationMode)
	{
		string str;
		try
		{
			if(!eutherm->status(str, *attr_AllowedStates_read))
			{
				set_state(Tango::ALARM);
				set_status(str);
			}
			eutherm->manual(attr_Manual_read);
		}
		catch(IpcException& e)
		{
			Tango::Except::throw_exception ("Write error",
				    e.what(), 
				    "Eurotherm2408::write_Setpoint",
					Tango::WARN);
		}
	}
	//	Set the attribute value
	attr.set_value(attr_Manual_read);

	/*----- PROTECTED REGION END -----*/	//	Eurotherm2408::read_Manual
}

//--------------------------------------------------------
/**
 *	Write Manual attribute values to hardware.
 *
 *	Data type:	Tango::DevBoolean
 *	Attr type:	Scalar 
 */
//--------------------------------------------------------
void Eurotherm2408::write_Manual(Tango::WAttribute &attr)
{
	DEBUG_STREAM << "Eurotherm2408::write_Manual(Tango::Attribute &attr) entering... " << endl;
	
	//	Retrieve write value
	Tango::DevBoolean	w_val;
	attr.get_write_value(w_val);
	
	/*----- PROTECTED REGION ID(Eurotherm2408::write_Manual) ENABLED START -----*/
	if(!simulationMode)
	{
		string str;
		try
		{
			if(!eutherm->status(str, *attr_AllowedStates_read))
			{
				set_state(Tango::ALARM);
				set_status(str);
			}
			eutherm->manual(w_val);
		}
		catch(IpcException& e)
		{
			Tango::Except::throw_exception ("Write error",
				    e.what(), 
				    "Eurotherm2408::write_Setpoint",
					Tango::WARN);
		}
	}
	else
	{
		*attr_Manual_read = w_val;
	}

	

	/*----- PROTECTED REGION END -----*/	//	Eurotherm2408::write_Manual
}

//--------------------------------------------------------
/**
 *	Read ProgramState attribute
 *	Description: Program state. Possible values:
 *	             
 *	             reset / run / hold /  complete
 *
 *	Data type:	Tango::DevString
 *	Attr type:	Scalar 
 */
//--------------------------------------------------------
void Eurotherm2408::read_ProgramState(Tango::Attribute &attr)
{
	DEBUG_STREAM << "Eurotherm2408::read_ProgramState(Tango::Attribute &attr) entering... " << endl;
	/*----- PROTECTED REGION ID(Eurotherm2408::read_ProgramState) ENABLED START -----*/
	if(!simulationMode)
	{
		string progstate;
		string str;
		try
		{
			if(!eutherm->status(str, *attr_AllowedStates_read))
			{
				set_state(Tango::ALARM);
				set_status(str);
			}
			eutherm->programStatus(&progstate);
		}
		catch(IpcException& e)
		{
			Tango::Except::throw_exception ("Write error",
				    e.what(), 
				    "Eurotherm2408::write_Setpoint",
					Tango::WARN);
		}
		*attr_ProgramState_read = CORBA::string_dup(progstate.c_str());
	}
	else
	{
		*attr_ProgramState_read = CORBA::string_dup("none");
	}
		//	Set the attribute value
	attr.set_value(attr_ProgramState_read);
	/*----- PROTECTED REGION END -----*/	//	Eurotherm2408::read_ProgramState
}
//--------------------------------------------------------
/**
 *	Read CurrentProgram attribute
 *	Description: Number of the currently running program.
 *
 *	Data type:	Tango::DevUShort
 *	Attr type:	Scalar 
 */
//--------------------------------------------------------
void Eurotherm2408::read_CurrentProgram(Tango::Attribute &attr)
{
	DEBUG_STREAM << "Eurotherm2408::read_CurrentProgram(Tango::Attribute &attr) entering... " << endl;
	/*----- PROTECTED REGION ID(Eurotherm2408::read_CurrentProgram) ENABLED START -----*/
	if(!simulationMode)
	{
		string str;
		try
		{	
			if(!eutherm->status(str, *attr_AllowedStates_read))
			{
				set_state(Tango::ALARM);
				set_status(str);
			}
			eutherm->currentProgram(attr_CurrentProgram_read);
		}
		catch(IpcException& e)
		{
			Tango::Except::throw_exception ("Write error",
				    e.what(), 
				    "Eurotherm2408::write_Setpoint",
					Tango::WARN);
		}
	}
	else
	{
		*attr_CurrentProgram_read = 0;
	}
	
	

	//	Set the attribute value
	attr.set_value(attr_CurrentProgram_read);

	/*----- PROTECTED REGION END -----*/	//	Eurotherm2408::read_CurrentProgram
}
//--------------------------------------------------------
/**
 *	Read CurrentSegment attribute
 *	Description: Number of the currently running segment.
 *
 *	Data type:	Tango::DevUShort
 *	Attr type:	Scalar 
 */
//--------------------------------------------------------
void Eurotherm2408::read_CurrentSegment(Tango::Attribute &attr)
{
	DEBUG_STREAM << "Eurotherm2408::read_CurrentSegment(Tango::Attribute &attr) entering... " << endl;
	/*----- PROTECTED REGION ID(Eurotherm2408::read_CurrentSegment) ENABLED START -----*/
	if(!simulationMode)
	{
		string str;
		try
		{
			if(!eutherm->status(str, *attr_AllowedStates_read))
			{
				set_state(Tango::ALARM);
				set_status(str);
			}
			eutherm->currentSegment(attr_CurrentSegment_read);
		}
		catch(IpcException& e)
		{
			Tango::Except::throw_exception ("Write error",
				    e.what(), 
				    "Eurotherm2408::write_Setpoint",
					Tango::WARN);
		}
	}
	else
	{
		*attr_CurrentSegment_read = 0;
	}

	//	Set the attribute value
	attr.set_value(attr_CurrentSegment_read);

	/*----- PROTECTED REGION END -----*/	//	Eurotherm2408::read_CurrentSegment
}
//--------------------------------------------------------
/**
 *	Read RemainingProgramTime attribute
 *	Description: Remaining program time in hours
 *
 *	Data type:	Tango::DevUShort
 *	Attr type:	Scalar 
 */
//--------------------------------------------------------
void Eurotherm2408::read_RemainingProgramTime(Tango::Attribute &attr)
{
	DEBUG_STREAM << "Eurotherm2408::read_RemainingProgramTime(Tango::Attribute &attr) entering... " << endl;
	/*----- PROTECTED REGION ID(Eurotherm2408::read_RemainingProgramTime) ENABLED START -----*/
	if(!simulationMode)
	{
		unsigned short ptime;
		string str;
		try
		{
			if(!eutherm->status(str, *attr_AllowedStates_read))
			{
				set_state(Tango::ALARM);
				set_status(str);
			}
			eutherm->timeProgram(&ptime);
		}
		catch(IpcException& e)
		{
			Tango::Except::throw_exception ("Write error",
				    e.what(), 
				    "Eurotherm2408::write_Setpoint",
					Tango::WARN);
		}
		*attr_RemainingProgramTime_read = ptime;
	}
	else
	{
		*attr_RemainingProgramTime_read = 0;
	} 


	//	Set the attribute value
	attr.set_value(attr_RemainingProgramTime_read);

	/*----- PROTECTED REGION END -----*/	//	Eurotherm2408::read_RemainingProgramTime
}
//--------------------------------------------------------
/**
 *	Read RemainingSegmentTime attribute
 *	Description: Remaining segment time in seconds
 *
 *	Data type:	Tango::DevUShort
 *	Attr type:	Scalar 
 */
//--------------------------------------------------------
void Eurotherm2408::read_RemainingSegmentTime(Tango::Attribute &attr)
{
	DEBUG_STREAM << "Eurotherm2408::read_RemainingSegmentTime(Tango::Attribute &attr) entering... " << endl;
	/*----- PROTECTED REGION ID(Eurotherm2408::read_RemainingSegmentTime) ENABLED START -----*/
	if(!simulationMode)
	{
		unsigned short stime;
		string str;
		try
		{
			if(!eutherm->status(str, *attr_AllowedStates_read))
			{
				set_state(Tango::ALARM);
				set_status(str);
			}
			eutherm->timeSegment(&stime);
		}
		catch(IpcException& e)
		{
			Tango::Except::throw_exception ("Write error",
				    e.what(), 
				    "Eurotherm2408::write_Setpoint",
					Tango::WARN);
		}
		*attr_RemainingSegmentTime_read = stime;
	}
	else
	{
		*attr_RemainingSegmentTime_read = 0;
	}

	//	Set the attribute value
	attr.set_value(attr_RemainingSegmentTime_read);

	/*----- PROTECTED REGION END -----*/	//	Eurotherm2408::read_RemainingSegmentTime
}
//--------------------------------------------------------
/**
 *	Read SegmentType attribute
 *	Description: The type of segment currently running.
 *
 *	Data type:	Tango::DevString
 *	Attr type:	Scalar 
 */
//--------------------------------------------------------
void Eurotherm2408::read_SegmentType(Tango::Attribute &attr)
{
	DEBUG_STREAM << "Eurotherm2408::read_SegmentType(Tango::Attribute &attr) entering... " << endl;
	/*----- PROTECTED REGION ID(Eurotherm2408::read_SegmentType) ENABLED START -----*/

	if(!simulationMode)
	{
		string segtype;
		unsigned short progstate;
		string str;
		try
		{
			if(!eutherm->status(str, *attr_AllowedStates_read))
			{
				set_state(Tango::ALARM);
				set_status(str);
			}
			eutherm->programStatus(&progstate);
			if(progstate == 0x1)
			{
				segtype = "n/a";
			}
			eutherm->currentSegmentType(&segtype);
		}
		catch(IpcException& e)
		{
			Tango::Except::throw_exception ("Write error",
				    e.what(), 
				    "Eurotherm2408::write_Setpoint",
					Tango::WARN);
		}
		*attr_SegmentType_read = CORBA::string_dup(segtype.c_str());
	}
	else
	{
		*attr_SegmentType_read = CORBA::string_dup("none");
	}
	//	Set the attribute value
	attr.set_value(attr_SegmentType_read);

	/*----- PROTECTED REGION END -----*/	//	Eurotherm2408::read_SegmentType
}
//--------------------------------------------------------
/**
 *	Read ProgramDir attribute
 *	Description: Path to directory containing controller programs
 *
 *	Data type:	Tango::DevString
 *	Attr type:	Scalar 
 */
//--------------------------------------------------------
void Eurotherm2408::read_ProgramDir(Tango::Attribute &attr)
{
	DEBUG_STREAM << "Eurotherm2408::read_ProgramDir(Tango::Attribute &attr) entering... " << endl;
	/*----- PROTECTED REGION ID(Eurotherm2408::read_ProgramDir) ENABLED START -----*/

	//	Set the attribute value
	if(*attr_ProgramDir_read)
	{
		attr.set_value(attr_ProgramDir_read);
	}

	/*----- PROTECTED REGION END -----*/	//	Eurotherm2408::read_ProgramDir
}

//--------------------------------------------------------
/**
 *	Write ProgramDir attribute values to hardware.
 *
 *	Data type:	Tango::DevString
 *	Attr type:	Scalar 
 */
//--------------------------------------------------------
void Eurotherm2408::write_ProgramDir(Tango::WAttribute &attr)
{
	DEBUG_STREAM << "Eurotherm2408::write_ProgramDir(Tango::Attribute &attr) entering... " << endl;
	
	//	Retrieve write value
	Tango::DevString	w_val;
	attr.get_write_value(w_val);
	
	/*----- PROTECTED REGION ID(Eurotherm2408::write_ProgramDir) ENABLED START -----*/
	if(*attr_ProgramDir_read)
	{
		delete *attr_ProgramDir_read;
	}
	*attr_ProgramDir_read = CORBA::string_dup(w_val);

	int retval;
	retval = ::mkdir(w_val, 0755);
	if(retval < 0)
	{
			if(errno != EEXIST)
			{
				delete *attr_ProgramDir_read;
				*attr_ProgramDir_read = 0;
				string msg(strerror(errno));
				Tango::Except::throw_exception ("Write error",
				    msg, 
				    "Eurotherm2408::write_ProgramDir",
					Tango::WARN);
			}
	}


	/*----- PROTECTED REGION END -----*/	//	Eurotherm2408::write_ProgramDir
}

//--------------------------------------------------------
/**
 *	Read MaxPrograms attribute
 *	Description: Maximum number of programs this controller can store.
 *
 *	Data type:	Tango::DevUShort
 *	Attr type:	Scalar 
 */
//--------------------------------------------------------
void Eurotherm2408::read_MaxPrograms(Tango::Attribute &attr)
{
	DEBUG_STREAM << "Eurotherm2408::read_MaxPrograms(Tango::Attribute &attr) entering... " << endl;
	/*----- PROTECTED REGION ID(Eurotherm2408::read_MaxPrograms) ENABLED START -----*/

	//	Set the attribute value
	attr.set_value(attr_MaxPrograms_read);
	//	Set the attribute value
	if(!simulationMode)
	{
		string str;
		try
		{
			if(!eutherm->status(str, *attr_AllowedStates_read))
			{
				set_state(Tango::ALARM);
				set_status(str);
			}
			eutherm->programmer(attr_MaxPrograms_read);
		}
		catch(IpcException& e)
		{
			Tango::Except::throw_exception ("Write error",
				    e.what(), 
				    "Eurotherm2408::write_Setpoint",
					Tango::WARN);
		}
	}
	else
	{
		*attr_MaxPrograms_read = 1;
	}
	attr.set_value(attr_MaxPrograms_read);

	/*----- PROTECTED REGION END -----*/	//	Eurotherm2408::read_MaxPrograms
}
//--------------------------------------------------------
/**
 *	Read AllowedStates attribute
 *	Description: Bitmask to set which bits of the controller status byte should
 *	             not set the device state to ALARM.
 *	             The status byte bit meaning is:
 *	             
 *	             0: ALARM1
 *	             1: ALARM2
 *	             2: ALARM3
 *	             3: ALARM4
 *	             4: MANUAL MODE
 *	             5: SENSOR FAILURE
 *	             6: LOOP BREAK
 *	             7: HEATER FAILURE
 *	             
 *	             So to e.g. not cause an alarm state on ALARM1 and MANUAL MODE set the
 *	             attribute to 17 ( = binary 00010001, bits 0 and 4 => 1).
 *
 *	Data type:	Tango::DevUChar
 *	Attr type:	Scalar 
 */
//--------------------------------------------------------
void Eurotherm2408::read_AllowedStates(Tango::Attribute &attr)
{
	DEBUG_STREAM << "Eurotherm2408::read_AllowedStates(Tango::Attribute &attr) entering... " << endl;
	/*----- PROTECTED REGION ID(Eurotherm2408::read_AllowedStates) ENABLED START -----*/

	//	Set the attribute value
	attr.set_value(attr_AllowedStates_read);

	/*----- PROTECTED REGION END -----*/	//	Eurotherm2408::read_AllowedStates
}

//--------------------------------------------------------
/**
 *	Write AllowedStates attribute values to hardware.
 *
 *	Data type:	Tango::DevUChar
 *	Attr type:	Scalar 
 */
//--------------------------------------------------------
void Eurotherm2408::write_AllowedStates(Tango::WAttribute &attr)
{
	DEBUG_STREAM << "Eurotherm2408::write_AllowedStates(Tango::Attribute &attr) entering... " << endl;
	
	//	Retrieve write value
	Tango::DevUChar	w_val;
	attr.get_write_value(w_val);
	
	/*----- PROTECTED REGION ID(Eurotherm2408::write_AllowedStates) ENABLED START -----*/

	*attr_AllowedStates_read = w_val;

	/*----- PROTECTED REGION END -----*/	//	Eurotherm2408::write_AllowedStates
}

//--------------------------------------------------------
/**
 *	Read HoldBack attribute
 *	Description: Report / set holdback state.
 *	              true = holdback enabled
 *	             false = holdback disabled 
 *
 *	Data type:	Tango::DevBoolean
 *	Attr type:	Scalar 
 */
//--------------------------------------------------------
void Eurotherm2408::read_HoldBack(Tango::Attribute &attr)
{
	DEBUG_STREAM << "Eurotherm2408::read_HoldBack(Tango::Attribute &attr) entering... " << endl;
	/*----- PROTECTED REGION ID(Eurotherm2408::read_HoldBack) ENABLED START -----*/

	//	Set the attribute value
	if(!simulationMode)
	{
		string str;
		try
		{
			if(!eutherm->status(str, *attr_AllowedStates_read))
			{
				set_state(Tango::ALARM);
				set_status(str);
			}
			eutherm->holdBack(attr_HoldBack_read);
		}
		catch(IpcException& e)
		{
			Tango::Except::throw_exception ("Read error",
				    e.what(), 
				    "Eurotherm2408::read_HoldBack",
					Tango::WARN);
		}
	}
	else
	{
		*attr_HoldBack_read = true;
	}
	attr.set_value(attr_HoldBack_read);

	/*----- PROTECTED REGION END -----*/	//	Eurotherm2408::read_HoldBack
}

//--------------------------------------------------------
/**
 *	Write HoldBack attribute values to hardware.
 *
 *	Data type:	Tango::DevBoolean
 *	Attr type:	Scalar 
 */
//--------------------------------------------------------
void Eurotherm2408::write_HoldBack(Tango::WAttribute &attr)
{
	DEBUG_STREAM << "Eurotherm2408::write_HoldBack(Tango::Attribute &attr) entering... " << endl;
	
	//	Retrieve write value
	Tango::DevBoolean	w_val;
	attr.get_write_value(w_val);
	
	/*----- PROTECTED REGION ID(Eurotherm2408::write_HoldBack) ENABLED START -----*/
	*attr_HoldBack_read = w_val;
	if(!simulationMode)
	{
		if(get_state() == Tango::ON)
		{
			try
			{
				eutherm->holdBack(w_val);
			}
			catch(IpcException& e)
			{
				Tango::Except::throw_exception ("Read error",
				    e.what(), 
				    "Eurotherm2408::read_HoldBack",
					Tango::WARN);
			}
		}
	}
	*attr_HoldBack_read = w_val;
	/*----- PROTECTED REGION END -----*/	//	Eurotherm2408::write_HoldBack
}

//--------------------------------------------------------
/**
 *	Read OutputLevel attribute
 *	Description: 
 *
 *	Data type:	Tango::DevDouble
 *	Attr type:	Scalar 
 */
//--------------------------------------------------------
void Eurotherm2408::read_OutputLevel(Tango::Attribute &attr)
{
	DEBUG_STREAM << "Eurotherm2408::read_OutputLevel(Tango::Attribute &attr) entering... " << endl;
	/*----- PROTECTED REGION ID(Eurotherm2408::read_OutputLevel) ENABLED START -----*/

	//	Set the attribute value
	if(!simulationMode)
	{
		if(get_state() == Tango::ON)
		{
			try
			{
				eutherm->outputLevel(attr_OutputLevel_read);
			}
			catch(IpcException& e)
			{
				Tango::Except::throw_exception ("Read error",
				    e.what(), 
				    "Eurotherm2408::read_OutputLevel",
					Tango::WARN);
			}
		}
	}

	attr.set_value(attr_OutputLevel_read);

	/*----- PROTECTED REGION END -----*/	//	Eurotherm2408::read_OutputLevel
}

//--------------------------------------------------------
/**
 *	Write OutputLevel attribute values to hardware.
 *
 *	Data type:	Tango::DevDouble
 *	Attr type:	Scalar 
 */
//--------------------------------------------------------
void Eurotherm2408::write_OutputLevel(Tango::WAttribute &attr)
{
	DEBUG_STREAM << "Eurotherm2408::write_OutputLevel(Tango::Attribute &attr) entering... " << endl;
	
	//	Retrieve write value
	Tango::DevDouble	w_val;
	attr.get_write_value(w_val);
	
	/*----- PROTECTED REGION ID(Eurotherm2408::write_OutputLevel) ENABLED START -----*/
	if(!simulationMode)
	{
		bool manual;
		try
		{
			eutherm->manual(&manual);
			if(!manual)
			{
				Tango::Except::throw_exception ("Write error",
					"Device has to be in manual mode !",
					"Eurotherm2408::write_OutputLevel",
					Tango::WARN);
			}
			eutherm->outputLevel(w_val);
		}
		catch(IpcException& e)
		{
			Tango::Except::throw_exception ("Write error",
			    e.what(), 
			    "Eurotherm2408::write_OutputLevel",
				Tango::WARN);
		}
	}
	else
	{
		*attr_OutputLevel_read = w_val;
	}		
	/*----- PROTECTED REGION END -----*/	//	Eurotherm2408::write_OutputLevel
}

//--------------------------------------------------------
/**
 *	Read OutputLevelMax attribute
 *	Description: 
 *
 *	Data type:	Tango::DevDouble
 *	Attr type:	Scalar 
 */
//--------------------------------------------------------
void Eurotherm2408::read_OutputLevelMax(Tango::Attribute &attr)
{
	DEBUG_STREAM << "Eurotherm2408::read_OutputLevelMax(Tango::Attribute &attr) entering... " << endl;
	/*----- PROTECTED REGION ID(Eurotherm2408::read_OutputLevelMax) ENABLED START -----*/
	if(!simulationMode)
	{
		try
		{
			eutherm->highPowerLimit(attr_OutputLevelMax_read);
		}
		catch(IpcException& e)
		{
			Tango::Except::throw_exception ("Read error",
			    e.what(), 
			    "Eurotherm2408::read_OutputLevelMax",
				Tango::WARN);
		}
	}
	//	Set the attribute value	
	attr.set_value(attr_OutputLevelMax_read);

	/*----- PROTECTED REGION END -----*/	//	Eurotherm2408::read_OutputLevelMax
}

//--------------------------------------------------------
/**
 *	Write OutputLevelMax attribute values to hardware.
 *
 *	Data type:	Tango::DevDouble
 *	Attr type:	Scalar 
 */
//--------------------------------------------------------
void Eurotherm2408::write_OutputLevelMax(Tango::WAttribute &attr)
{
	DEBUG_STREAM << "Eurotherm2408::write_OutputLevelMax(Tango::Attribute &attr) entering... " << endl;
	
	//	Retrieve write value
	Tango::DevDouble	w_val;
	attr.get_write_value(w_val);
	
	/*----- PROTECTED REGION ID(Eurotherm2408::write_OutputLevelMax) ENABLED START -----*/
	if(!simulationMode)
	{
		try
		{
			eutherm->highPowerLimit(w_val);
		}
		catch(IpcException& e)
		{
			Tango::Except::throw_exception ("Write error",
			    e.what(), 
			    "Eurotherm2408::write_OutputLevelMax",
				Tango::WARN);
		}
	}
	*attr_OutputLevelMax_read = w_val;
	

	/*----- PROTECTED REGION END -----*/	//	Eurotherm2408::write_OutputLevelMax
}

//--------------------------------------------------------
/**
 *	Read OutputLevelMin attribute
 *	Description: 
 *
 *	Data type:	Tango::DevDouble
 *	Attr type:	Scalar 
 */
//--------------------------------------------------------
void Eurotherm2408::read_OutputLevelMin(Tango::Attribute &attr)
{
	DEBUG_STREAM << "Eurotherm2408::read_OutputLevelMin(Tango::Attribute &attr) entering... " << endl;
	/*----- PROTECTED REGION ID(Eurotherm2408::read_OutputLevelMin) ENABLED START -----*/

	if(!simulationMode)
	{
		try
		{
			eutherm->lowPowerLimit(attr_OutputLevelMin_read);
		}
		catch(IpcException& e)
		{
			Tango::Except::throw_exception ("Read error",
			    e.what(), 
			    "Eurotherm2408::read_OutputLevelMin",
				Tango::WARN);
		}
	}
	//	Set the attribute value
	attr.set_value(attr_OutputLevelMin_read);
	/*----- PROTECTED REGION END -----*/	//	Eurotherm2408::read_OutputLevelMin
}

//--------------------------------------------------------
/**
 *	Write OutputLevelMin attribute values to hardware.
 *
 *	Data type:	Tango::DevDouble
 *	Attr type:	Scalar 
 */
//--------------------------------------------------------
void Eurotherm2408::write_OutputLevelMin(Tango::WAttribute &attr)
{
	DEBUG_STREAM << "Eurotherm2408::write_OutputLevelMin(Tango::Attribute &attr) entering... " << endl;
	
	//	Retrieve write value
	Tango::DevDouble	w_val;
	attr.get_write_value(w_val);
	
	/*----- PROTECTED REGION ID(Eurotherm2408::write_OutputLevelMin) ENABLED START -----*/
	if(!simulationMode)
	{
		try
		{
			eutherm->lowPowerLimit(w_val);
		}
		catch(IpcException& e)
		{
			Tango::Except::throw_exception ("Write error",
			    e.what(), 
			    "Eurotherm2408::write_OutputLevelMin",
				Tango::WARN);
		}
	}
	*attr_OutputLevelMin_read = w_val;
	

	/*----- PROTECTED REGION END -----*/	//	Eurotherm2408::write_OutputLevelMin
}


//--------------------------------------------------------
/**
 *	Method      : Eurotherm2408::Eurotherm2408Class::add_dynamic_attributes()
 *	Description : Create the dynamic attributes if any
 *	              for specified device.
 */
//--------------------------------------------------------
void Eurotherm2408::add_dynamic_attributes()
{
	/*----- PROTECTED REGION ID(Eurotherm2408::Class::add_dynamic_attributes) ENABLED START -----*/

	//	Add your own code to create and add dynamic attributes if any

	/*----- PROTECTED REGION END -----*/	//	Eurotherm2408::Class::add_dynamic_attributes

}



//========================================================
//	Command execution methods
//========================================================

//--------------------------------------------------------
/**
 *	Execute the StartProgram command:
 *	Description: Start a program stored in the controller. The max. program number depends
 *	             on the hardware, can be 0, 1, 4 or 20. Check with reading attribute MaxPrograms.
 *
 *	@param argin program number
 *	@returns 
 */
//--------------------------------------------------------
void Eurotherm2408::start_program(Tango::DevUShort argin)
{
	DEBUG_STREAM << "Eurotherm2408::StartProgram()  - " << device_name << endl;
	/*----- PROTECTED REGION ID(Eurotherm2408::start_program) ENABLED START -----*/

	//	Add your own code
	if(!simulationMode)
	{
		bool manual;
		string progstate;
		bool has;
		try
		{
			cerr << "manual\n";
        	eutherm->manual(&manual);
        	if(manual)
        	{
            	Tango::Except::throw_exception ("Write error",
                    "Device must not be in manual mode !",
                    "Eurotherm2408::write_OutputLevel",
                    Tango::WARN);
        	}
			cerr << "programStatus\n";
			eutherm->programStatus(&progstate);
			if(progstate == "run")
			{
				Tango::Except::throw_exception ("Write error",
				    "Program already running", 
				    "Eurotherm2408::start_program",
					Tango::WARN);
			}
			cerr << "hasProgram\n";
			eutherm->hasProgram(1, &has);
			if(!has)
			{
				Tango::Except::throw_exception ("Write error",
				    "No programm in controller memory", 
				    "Eurotherm2408::start_program",
					Tango::WARN);
			}
			progstate = "run";
			cerr << "programStatus\n";
			eutherm->programStatus(progstate);
		}
		catch(IpcException& e)
		{	
			Tango::Except::throw_exception ("Write error",
				    e.what(), 
				    "Eurotherm2408::start_program",
					Tango::WARN);
		}
	}

	/*----- PROTECTED REGION END -----*/	//	Eurotherm2408::start_program

}

//--------------------------------------------------------
/**
 *	Execute the StopProgram command:
 *	Description: Stop currently running program
 *
 *	@param argin 
 *	@returns 
 */
//--------------------------------------------------------
void Eurotherm2408::stop_program()
{
	DEBUG_STREAM << "Eurotherm2408::StopProgram()  - " << device_name << endl;
	/*----- PROTECTED REGION ID(Eurotherm2408::stop_program) ENABLED START -----*/

	//	Add your own code
	if(!simulationMode)
	{
		string progstate;
		try
		{
			eutherm->programStatus(&progstate);
			if(progstate == "reset")
			{
				Tango::Except::throw_exception ("Write error",
				    "No program running", 
				    "Eurotherm2408::start_program",
					Tango::WARN);
			}
			progstate = "reset";
			eutherm->programStatus(progstate);
		}
		catch(IpcException& e)
		{
			Tango::Except::throw_exception ("Write error",
				    e.what(), 
				    "Eurotherm2408::start_program",
					Tango::WARN);
		}
	}

	/*----- PROTECTED REGION END -----*/	//	Eurotherm2408::stop_program

}

//--------------------------------------------------------
/**
 *	Execute the HoldProgram command:
 *	Description: Hold currently running program
 *
 *	@param argin 
 *	@returns 
 */
//--------------------------------------------------------
void Eurotherm2408::hold_program()
{
	DEBUG_STREAM << "Eurotherm2408::HoldProgram()  - " << device_name << endl;
	/*----- PROTECTED REGION ID(Eurotherm2408::hold_program) ENABLED START -----*/

	//	Add your own code
	//	Add your own code
	if(!simulationMode)
	{
		string progstate;
		try
		{
			eutherm->programStatus(&progstate);
			if(progstate != "run")
			{
				Tango::Except::throw_exception ("Write error",
				    "No program running", 
				    "Eurotherm2408::start_program",
					Tango::WARN);
			}
			progstate = "hold";
			eutherm->programStatus(progstate);
		}
		catch(IpcException& e)
		{
			Tango::Except::throw_exception ("Write error",
				    e.what(), 
				    "Eurotherm2408::start_program",
					Tango::WARN);
		}
	}

	/*----- PROTECTED REGION END -----*/	//	Eurotherm2408::hold_program

}

//--------------------------------------------------------
/**
 *	Execute the LoadProgram command:
 *	Description: Loads a program into controller memory
 *
 *	@param argin path to program file, either absolute or relative to attribute ProgramDir
 *	@returns 
 */
//--------------------------------------------------------
void Eurotherm2408::load_program(Tango::DevString argin)
{
	DEBUG_STREAM << "Eurotherm2408::LoadProgram()  - " << device_name << endl;
	/*----- PROTECTED REGION ID(Eurotherm2408::load_program) ENABLED START -----*/

	//	Add your own code
	string path(argin);
	ifstream infile;
	// first try absolute path
	infile.open(path.c_str());
	if(!infile.is_open())
	{
		// if ProgramDir is set. look in program dir
		if(*attr_ProgramDir_read)
		{
			path = *attr_ProgramDir_read;
			path += '/'; // just in case it was omitted
			path += argin;
			infile.open(path.c_str());
			if(!infile.is_open())
			{
				
				string msg("Open error on ");
				msg += argin;
				Tango::Except::throw_exception ("Write error",
				    msg, 
				    "Eurotherm2408::load_program",
					Tango::WARN);
			}
		}
	}
	infile.close();
	// if we got this far, argin exists, is in path and readable
	// now check whether it is a proper file or not
	struct stat buffer;
	if(stat(path.c_str(), &buffer) < 0)
	{
		string msg("Stat error on ");
				msg += argin;
				Tango::Except::throw_exception ("Write error",
				    msg, 
				    "Eurotherm2408::load_program",
					Tango::WARN);
	}
	if(!S_ISREG(buffer.st_mode))
	{
			string msg("Not a regular file: ");
				msg += argin;
				Tango::Except::throw_exception ("Write error",
				    msg, 
				    "Eurotherm2408::load_program",
					Tango::WARN);
	}
	if(!simulationMode)
	{
		string progstate;
		try
		{
			eutherm->programStatus(&progstate);
			if(progstate != "reset")
			{
				Tango::Except::throw_exception ("Write error",
				    "Program running, stop first", 
				    "Eurotherm2408::start_program",
					Tango::WARN);
			}
			eutherm->loadProgram(path);
			eutherm->deleteProgram(1);
			eutherm->holdBack(attr_HoldBack_read);
			eutherm->writeProgram(1);
		}
		catch(IpcException& e)
		{
			Tango::Except::throw_exception ("Write error",
				    e.what(), 
				    "Eurotherm2408::write_program",
					Tango::WARN);
		}
	}

	/*----- PROTECTED REGION END -----*/	//	Eurotherm2408::load_program

}

//--------------------------------------------------------
/**
 *	Execute the DeleteProgram command:
 *	Description: removes program from controller memory
 *
 *	@param argin Program number
 *	@returns 
 */
//--------------------------------------------------------
void Eurotherm2408::delete_program(Tango::DevUShort argin)
{
	DEBUG_STREAM << "Eurotherm2408::DeleteProgram()  - " << device_name << endl;
	/*----- PROTECTED REGION ID(Eurotherm2408::delete_program) ENABLED START -----*/

	//	Add your own code
	string progstate;
	try
	{
		eutherm->programStatus(&progstate);
		if(progstate != "reset")
		{
			Tango::Except::throw_exception ("Write error",
			    "Program running, stop first", 
			    "Eurotherm2408::delete_program",
				Tango::WARN);
		}
		eutherm->deleteProgram(argin);
	}
	catch(IpcException& e)
	{
			Tango::Except::throw_exception ("Write error",
				    e.what(), 
				    "Eurotherm2408::delete_program",
					Tango::WARN);
	}

	/*----- PROTECTED REGION END -----*/	//	Eurotherm2408::delete_program

}


	/*----- PROTECTED REGION ID(Eurotherm2408::namespace_ending) ENABLED START -----*/

	//	Additional Methods

	/*----- PROTECTED REGION END -----*/	//	Eurotherm2408::namespace_ending
} //	namespace
