/*----- PROTECTED REGION ID(Eurotherm2408.h) ENABLED START -----*/
//=============================================================================
//
// file :        Eurotherm2408.h
//
// description : Include for the Eurotherm2408 class.
//
// project :     Eurotherm2408.
//
// $Author:  $
//
// $Revision:  $
// $Date:  $
//
// SVN only:
// $HeadURL:  $
//
// CVS only:
// $Source:  $
// $Log:  $
//
//=============================================================================
//                This file is generated by POGO
//        (Program Obviously used to Generate tango Object)
//=============================================================================


#ifndef EUROTHERM2408_H
#define EUROTHERM2408_H


#include <tango.h>
#include "ctrl/Eurotherm2408.h"





/*----- PROTECTED REGION END -----*/


/**
 *	Eurotherm2408 class Description:
 *	
 */

namespace Eurotherm2408_ns
{
	/*----- PROTECTED REGION ID(Eurotherm2408::Additional Class Declarations) ENABLED START -----*/

		//		Additional Class Declarations

	/*----- PROTECTED REGION END -----*/	//	Eurotherm2408::Additional Class Declarations


class Eurotherm2408 : public Tango::Device_4Impl
{


	/*----- PROTECTED REGION ID(Eurotherm2408::Data Members) ENABLED START -----*/

	//		Add your own data members
public:



	/*----- PROTECTED REGION END -----*/	//	Eurotherm2408::Data Members


//	Device property data members
public:		//	HostName:	Hostname or IP address
	string	hostName;
	//	PortNumber:	TCP Port Number.
	string	portNumber;
	//	DeviceAddress:	Address of device (adjusted at hardware)
	Tango::DevShort	deviceAddress;
	//	SimulationMode:	
	Tango::DevShort	simulationMode;
	//	LogicOps:	true, if the hardware supports logical operations
	Tango::DevBoolean	logicOps;
	//	ConnectType:	connection type, either `serial` or `net`
	string	connectType;
	//	DeviceFile:	tty device file name
	string	deviceFile;
	//	BaudRate:	tty device baud rate
	Tango::DevLong	baudRate;
	

//	Attribute data members
public:
	Tango::DevDouble	*attr_Temperature_read;
	Tango::DevDouble	*attr_Setpoint_read;
	Tango::DevBoolean	*attr_Manual_read;
	Tango::DevString	*attr_ProgramState_read;
	Tango::DevUShort	*attr_CurrentProgram_read;
	Tango::DevUShort	*attr_CurrentSegment_read;
	Tango::DevUShort	*attr_RemainingProgramTime_read;
	Tango::DevUShort	*attr_RemainingSegmentTime_read;
	Tango::DevString	*attr_SegmentType_read;
	Tango::DevString	*attr_ProgramDir_read;
	Tango::DevUShort	*attr_MaxPrograms_read;
	Tango::DevUChar	*attr_AllowedStates_read;
	Tango::DevBoolean	*attr_HoldBack_read;
	Tango::DevDouble	*attr_OutputLevel_read;
	Tango::DevDouble	*attr_OutputLevelMax_read;
	Tango::DevDouble	*attr_OutputLevelMin_read;



//	Constructors and destructors
public:
	/**
	 * Constructs a newly allocated Command object.
	 *
	 *	@param cl	Class.
	 *	@param s 	Device Name
	 */
	Eurotherm2408(Tango::DeviceClass *cl,string &s);
	/**
	 * Constructs a newly allocated Command object.
	 *
	 *	@param cl	Class.
	 *	@param s 	Device Name
	 */
	Eurotherm2408(Tango::DeviceClass *cl,const char *s);
	/**
	 * Constructs a newly allocated Command object.
	 *
	 *	@param cl	Class.
	 *	@param s 	Device name
	 *	@param d	Device description.
	 */
	Eurotherm2408(Tango::DeviceClass *cl,const char *s,const char *d);
	/**
	 * The object destructor.
	 */	
	~Eurotherm2408() {delete_device();};



//	Miscellaneous methods
public:
	/**
	 *	will be called at device destruction or at init command.
	 */
	void delete_device();
	/**
	 *	Initialize the device
	 */
	virtual void init_device();
	/**
	 *	Read the device properties from database
	 */
	 void get_device_property();
	/**
	 *	Always executed method before execution command method.
	 */
	virtual void always_executed_hook();


//	Attribute methods
public:
	/**
	 *	Method      : Eurotherm2408::read_attr_hardware()
	 *	Description : Hardware acquisition for attributes.
	 */
	virtual void read_attr_hardware(vector<long> &attr_list);


	/**
	 *	Temperature attribute related methods.
	 *	Description: The current temperature
	 *
	 *	Data type:	Tango::DevDouble
	 *	Attr type:	Scalar 
	 */
	virtual void read_Temperature(Tango::Attribute &attr);
	virtual bool is_Temperature_allowed(Tango::AttReqType type);



	/**
	 *	Setpoint attribute related methods.
	 *	Description: The current temperature setpoint
	 *
	 *	Data type:	Tango::DevDouble
	 *	Attr type:	Scalar 
	 */
	virtual void read_Setpoint(Tango::Attribute &attr);
	virtual void write_Setpoint(Tango::WAttribute &attr);
	virtual bool is_Setpoint_allowed(Tango::AttReqType type);



	/**
	 *	Manual attribute related methods.
	 *	Description: Manual mode (true = on, false = off)
	 *
	 *	Data type:	Tango::DevBoolean
	 *	Attr type:	Scalar 
	 */
	virtual void read_Manual(Tango::Attribute &attr);
	virtual void write_Manual(Tango::WAttribute &attr);
	virtual bool is_Manual_allowed(Tango::AttReqType type);



	/**
	 *	ProgramState attribute related methods.
	 *	Description: Program state. Possible values:
 *	             
 *	             reset / run / hold /  complete
	 *
	 *	Data type:	Tango::DevString
	 *	Attr type:	Scalar 
	 */
	virtual void read_ProgramState(Tango::Attribute &attr);
	virtual bool is_ProgramState_allowed(Tango::AttReqType type);



	/**
	 *	CurrentProgram attribute related methods.
	 *	Description: Number of the currently running program.
	 *
	 *	Data type:	Tango::DevUShort
	 *	Attr type:	Scalar 
	 */
	virtual void read_CurrentProgram(Tango::Attribute &attr);
	virtual bool is_CurrentProgram_allowed(Tango::AttReqType type);



	/**
	 *	CurrentSegment attribute related methods.
	 *	Description: Number of the currently running segment.
	 *
	 *	Data type:	Tango::DevUShort
	 *	Attr type:	Scalar 
	 */
	virtual void read_CurrentSegment(Tango::Attribute &attr);
	virtual bool is_CurrentSegment_allowed(Tango::AttReqType type);



	/**
	 *	RemainingProgramTime attribute related methods.
	 *	Description: Remaining program time in hours
	 *
	 *	Data type:	Tango::DevUShort
	 *	Attr type:	Scalar 
	 */
	virtual void read_RemainingProgramTime(Tango::Attribute &attr);
	virtual bool is_RemainingProgramTime_allowed(Tango::AttReqType type);



	/**
	 *	RemainingSegmentTime attribute related methods.
	 *	Description: Remaining segment time in seconds
	 *
	 *	Data type:	Tango::DevUShort
	 *	Attr type:	Scalar 
	 */
	virtual void read_RemainingSegmentTime(Tango::Attribute &attr);
	virtual bool is_RemainingSegmentTime_allowed(Tango::AttReqType type);



	/**
	 *	SegmentType attribute related methods.
	 *	Description: The type of segment currently running.
	 *
	 *	Data type:	Tango::DevString
	 *	Attr type:	Scalar 
	 */
	virtual void read_SegmentType(Tango::Attribute &attr);
	virtual bool is_SegmentType_allowed(Tango::AttReqType type);



	/**
	 *	ProgramDir attribute related methods.
	 *	Description: Path to directory containing controller programs
	 *
	 *	Data type:	Tango::DevString
	 *	Attr type:	Scalar 
	 */
	virtual void read_ProgramDir(Tango::Attribute &attr);
	virtual void write_ProgramDir(Tango::WAttribute &attr);
	virtual bool is_ProgramDir_allowed(Tango::AttReqType type);



	/**
	 *	MaxPrograms attribute related methods.
	 *	Description: Maximum number of programs this controller can store.
	 *
	 *	Data type:	Tango::DevUShort
	 *	Attr type:	Scalar 
	 */
	virtual void read_MaxPrograms(Tango::Attribute &attr);
	virtual bool is_MaxPrograms_allowed(Tango::AttReqType type);



	/**
	 *	AllowedStates attribute related methods.
	 *	Description: Bitmask to set which bits of the controller status byte should
 *	             not set the device state to ALARM.
 *	             The status byte bit meaning is:
 *	             
 *	             0: ALARM1
 *	             1: ALARM2
 *	             2: ALARM3
 *	             3: ALARM4
 *	             4: MANUAL MODE
 *	             5: SENSOR FAILURE
 *	             6: LOOP BREAK
 *	             7: HEATER FAILURE
 *	             
 *	             So to e.g. not cause an alarm state on ALARM1 and MANUAL MODE set the
 *	             attribute to 17 ( = binary 00010001, bits 0 and 4 => 1).
	 *
	 *	Data type:	Tango::DevUChar
	 *	Attr type:	Scalar 
	 */
	virtual void read_AllowedStates(Tango::Attribute &attr);
	virtual void write_AllowedStates(Tango::WAttribute &attr);
	virtual bool is_AllowedStates_allowed(Tango::AttReqType type);



	/**
	 *	HoldBack attribute related methods.
	 *	Description: Report / set holdback state.
 *	              true = holdback enabled
 *	             false = holdback disabled 
	 *
	 *	Data type:	Tango::DevBoolean
	 *	Attr type:	Scalar 
	 */
	virtual void read_HoldBack(Tango::Attribute &attr);
	virtual void write_HoldBack(Tango::WAttribute &attr);
	virtual bool is_HoldBack_allowed(Tango::AttReqType type);



	/**
	 *	OutputLevel attribute related methods.
	 *	Description: 
	 *
	 *	Data type:	Tango::DevDouble
	 *	Attr type:	Scalar 
	 */
	virtual void read_OutputLevel(Tango::Attribute &attr);
	virtual void write_OutputLevel(Tango::WAttribute &attr);
	virtual bool is_OutputLevel_allowed(Tango::AttReqType type);



	/**
	 *	OutputLevelMax attribute related methods.
	 *	Description: 
	 *
	 *	Data type:	Tango::DevDouble
	 *	Attr type:	Scalar 
	 */
	virtual void read_OutputLevelMax(Tango::Attribute &attr);
	virtual void write_OutputLevelMax(Tango::WAttribute &attr);
	virtual bool is_OutputLevelMax_allowed(Tango::AttReqType type);



	/**
	 *	OutputLevelMin attribute related methods.
	 *	Description: 
	 *
	 *	Data type:	Tango::DevDouble
	 *	Attr type:	Scalar 
	 */
	virtual void read_OutputLevelMin(Tango::Attribute &attr);
	virtual void write_OutputLevelMin(Tango::WAttribute &attr);
	virtual bool is_OutputLevelMin_allowed(Tango::AttReqType type);



	/**
	 *	Method      : Eurotherm2408::add_dynamic_attributes()
	 *	Description : Add dynamic attributes if any.
	 */
		void add_dynamic_attributes();

//	Command related methods
public: 


	/**
	 *	Command StartProgram related methods.
	 */
	void start_program(Tango::DevUShort argin);
	virtual bool is_StartProgram_allowed(const CORBA::Any &any);

	/**
	 *	Command StopProgram related methods.
	 */
	void stop_program();
	virtual bool is_StopProgram_allowed(const CORBA::Any &any);

	/**
	 *	Command HoldProgram related methods.
	 */
	void hold_program();
	virtual bool is_HoldProgram_allowed(const CORBA::Any &any);

	/**
	 *	Command LoadProgram related methods.
	 */
	void load_program(Tango::DevString argin);
	virtual bool is_LoadProgram_allowed(const CORBA::Any &any);

	/**
	 *	Command DeleteProgram related methods.
	 */
	void delete_program(Tango::DevUShort argin);
	virtual bool is_DeleteProgram_allowed(const CORBA::Any &any);



	/*----- PROTECTED REGION ID(Eurotherm2408::Additional Method prototypes) ENABLED START -----*/

	//	Additional Method prototypes
protected :	
	Eurotherm2408ctrl* eutherm;
	Tango::DevBoolean tty_debug;

	/*----- PROTECTED REGION END -----*/	//	Eurotherm2408::Additional Method prototypes

};

	/*----- PROTECTED REGION ID(Eurotherm2408::Additional Classes Definitions) ENABLED START -----*/

	//	Additional Classes definitions

	/*----- PROTECTED REGION END -----*/	//	Eurotherm2408::Additional Classes Definitions

} //	namespace

#endif	//	EUROTHERM2408_H
