/*----- PROTECTED REGION ID(Eurotherm2408Class.cpp) ENABLED START -----*/
static const char *RcsId      = "$Id:  $";
static const char *TagName    = "$Name:  $";
static const char *CvsPath    = "$Source:  $";
static const char *SvnPath    = "$HeadURL:  $";
static const char *HttpServer = "http://www.esrf.eu/computing/cs/tango/tango_doc/ds_doc/";
//=============================================================================
//
// file :        Eurotherm2408Class.cpp
//
// description : C++ source for the Eurotherm2408Class. A singleton
//               class derived from DeviceClass. It implements the
//               command list and all properties and methods required
//               by the name once per process.
//
// project :     Eurotherm2408.
//
// $Author:  $
//
// $Revision:  $
// $Date:  $
//
// SVN only:
// $HeadURL:  $
//
// CVS only:
// $Source:  $
// $Log:  $
//
//=============================================================================
//                This file is generated by POGO
//        (Program Obviously used to Generate tango Object)
//=============================================================================


#include <tango.h>
#include <Eurotherm2408.h>
#include <Eurotherm2408Class.h>

/*----- PROTECTED REGION END -----*/

//-------------------------------------------------------------------
/**
 *	Create Eurotherm2408Class singleton and
 *	return it in a C function for Python usage
 */
//-------------------------------------------------------------------
extern "C" {
#ifdef _TG_WINDOWS_

__declspec(dllexport)

#endif

	Tango::DeviceClass *_create_Eurotherm2408_class(const char *name) {
		return Eurotherm2408_ns::Eurotherm2408Class::init(name);
	}
}


namespace Eurotherm2408_ns
{


//===================================================================
//	Initialize pointer for singleton pattern
//===================================================================
Eurotherm2408Class *Eurotherm2408Class::_instance = NULL;

//--------------------------------------------------------
/**
 * method : 		Eurotherm2408Class::Eurotherm2408Class(string &s)
 * description : 	constructor for the Eurotherm2408Class
 *
 * @param s	The class name
 */
//--------------------------------------------------------
Eurotherm2408Class::Eurotherm2408Class(string &s):DeviceClass(s)
{
	cout2 << "Entering Eurotherm2408Class constructor" << endl;
	set_default_property();
	get_class_property();
	write_class_property();

	/*----- PROTECTED REGION ID(Eurotherm2408::Class::constructor) ENABLED START -----*/
	

	/*----- PROTECTED REGION END -----*/	//	Eurotherm2408::Class::constructor

	cout2 << "Leaving Eurotherm2408Class constructor" << endl;
}


//--------------------------------------------------------
/**
 * method : 		Eurotherm2408Class::~Eurotherm2408Class()
 * description : 	destructor for the Eurotherm2408Class
 */
//--------------------------------------------------------
Eurotherm2408Class::~Eurotherm2408Class()
{
	/*----- PROTECTED REGION ID(Eurotherm2408::Class::destructor) ENABLED START -----*/

	/*----- PROTECTED REGION END -----*/	//	Eurotherm2408::Class::destructor

	_instance = NULL;
}


//--------------------------------------------------------
/**
 * method : 		Eurotherm2408Class::init
 * description : 	Create the object if not already done.
 *                  Otherwise, just return a pointer to the object
 *
 * @param	name	The class name
 */
//--------------------------------------------------------
Eurotherm2408Class *Eurotherm2408Class::init(const char *name)
{
	if (_instance == NULL)
	{
		try
		{
			string s(name);
			_instance = new Eurotherm2408Class(s);
		}
		catch (bad_alloc)
		{
			throw;
		}		
	}		
	return _instance;
}

//--------------------------------------------------------
/**
 * method : 		Eurotherm2408Class::instance
 * description : 	Check if object already created,
 *                  and return a pointer to the object
 */
//--------------------------------------------------------
Eurotherm2408Class *Eurotherm2408Class::instance()
{
	if (_instance == NULL)
	{
		cerr << "Class is not initialised !!" << endl;
		exit(-1);
	}
	return _instance;
}




//===================================================================
//	Command execution method calls
//===================================================================
//--------------------------------------------------------
/**
 * method : 		StartProgramClass::execute()
 * description : 	method to trigger the execution of the command.
 *
 * @param	device	The device on which the command must be executed
 * @param	in_any	The command input data
 *
 *	returns The command output data (packed in the Any object)
 */
//--------------------------------------------------------
CORBA::Any *StartProgramClass::execute(Tango::DeviceImpl *device, const CORBA::Any &in_any)
{
	cout2 << "StartProgramClass::execute(): arrived" << endl;

	Tango::DevUShort	argin;
	extract(in_any, argin);
	((static_cast<Eurotherm2408 *>(device))->start_program(argin));
	return new CORBA::Any();
}
//--------------------------------------------------------
/**
 * method : 		StopProgramClass::execute()
 * description : 	method to trigger the execution of the command.
 *
 * @param	device	The device on which the command must be executed
 * @param	in_any	The command input data
 *
 *	returns The command output data (packed in the Any object)
 */
//--------------------------------------------------------
CORBA::Any *StopProgramClass::execute(Tango::DeviceImpl *device, const CORBA::Any &in_any)
{
	cout2 << "StopProgramClass::execute(): arrived" << endl;

	
	((static_cast<Eurotherm2408 *>(device))->stop_program());
	return new CORBA::Any();
}
//--------------------------------------------------------
/**
 * method : 		HoldProgramClass::execute()
 * description : 	method to trigger the execution of the command.
 *
 * @param	device	The device on which the command must be executed
 * @param	in_any	The command input data
 *
 *	returns The command output data (packed in the Any object)
 */
//--------------------------------------------------------
CORBA::Any *HoldProgramClass::execute(Tango::DeviceImpl *device, const CORBA::Any &in_any)
{
	cout2 << "HoldProgramClass::execute(): arrived" << endl;

	
	((static_cast<Eurotherm2408 *>(device))->hold_program());
	return new CORBA::Any();
}
//--------------------------------------------------------
/**
 * method : 		LoadProgramClass::execute()
 * description : 	method to trigger the execution of the command.
 *
 * @param	device	The device on which the command must be executed
 * @param	in_any	The command input data
 *
 *	returns The command output data (packed in the Any object)
 */
//--------------------------------------------------------
CORBA::Any *LoadProgramClass::execute(Tango::DeviceImpl *device, const CORBA::Any &in_any)
{
	cout2 << "LoadProgramClass::execute(): arrived" << endl;

	Tango::DevString	argin;
	extract(in_any, argin);
	((static_cast<Eurotherm2408 *>(device))->load_program(argin));
	return new CORBA::Any();
}
//--------------------------------------------------------
/**
 * method : 		DeleteProgramClass::execute()
 * description : 	method to trigger the execution of the command.
 *
 * @param	device	The device on which the command must be executed
 * @param	in_any	The command input data
 *
 *	returns The command output data (packed in the Any object)
 */
//--------------------------------------------------------
CORBA::Any *DeleteProgramClass::execute(Tango::DeviceImpl *device, const CORBA::Any &in_any)
{
	cout2 << "DeleteProgramClass::execute(): arrived" << endl;

	Tango::DevUShort	argin;
	extract(in_any, argin);
	((static_cast<Eurotherm2408 *>(device))->delete_program(argin));
	return new CORBA::Any();
}




//===================================================================
//	Properties management
//===================================================================

//--------------------------------------------------------
/**
 * method : 		Eurotherm2408Class::get_class_property
 * description : 	Get the class property for specified name.
 *
 * @param	name  The property name
 */
//--------------------------------------------------------
Tango::DbDatum Eurotherm2408Class::get_class_property(string &prop_name)
{
	for (unsigned int i=0 ; i<cl_prop.size() ; i++)
		if (cl_prop[i].name == prop_name)
			return cl_prop[i];
	//	if not found, returns  an empty DbDatum
	return Tango::DbDatum(prop_name);
}


//--------------------------------------------------------
/**
 *	Method      : Eurotherm2408::Eurotherm2408Class::get_default_device_property()()
 *	Description : Return the default value for device property.
 */
//--------------------------------------------------------
Tango::DbDatum Eurotherm2408Class::get_default_device_property(string &prop_name)
{
	for (unsigned int i=0 ; i<dev_def_prop.size() ; i++)
		if (dev_def_prop[i].name == prop_name)
			return dev_def_prop[i];
	//	if not found, return  an empty DbDatum
	return Tango::DbDatum(prop_name);
}


//--------------------------------------------------------
/**
 *	Method      : Eurotherm2408::Eurotherm2408Class::get_default_class_property()()
 *	Description : Return the default value for class property.
 */
//--------------------------------------------------------
Tango::DbDatum Eurotherm2408Class::get_default_class_property(string &prop_name)
{
	for (unsigned int i=0 ; i<cl_def_prop.size() ; i++)
		if (cl_def_prop[i].name == prop_name)
			return cl_def_prop[i];
	//	if not found, return  an empty DbDatum
	return Tango::DbDatum(prop_name);
}


//--------------------------------------------------------
/**
 *	Method      : Eurotherm2408::Eurotherm2408Class::get_class_property()
 *	Description : //	Add your own code to initialize
 */
//--------------------------------------------------------
void Eurotherm2408Class::get_class_property()
{
}


//--------------------------------------------------------
/**
 *	Method      : Eurotherm2408::Eurotherm2408Class::set_default_property()
 *	Description : Set default property (class and device) for wizard.
 *	              For each property, add to wizard property name and description.
 *	              If default value has been set, add it to wizard property and.
 *	              store it in a DbDatum.
 */
//--------------------------------------------------------
void Eurotherm2408Class::set_default_property()
{
	string	prop_name;
	string	prop_desc;
	string	prop_def;
	vector<string>	vect_data;
	
	//	Set Default Class Properties

	//	Set Default Device Properties

	prop_name = "HostName";
	prop_desc = "Hostname or IP address";
	prop_def  = """\n";
	vect_data.clear();
	vect_data.push_back("""");
	if (prop_def.length()>0)
	{
		Tango::DbDatum	data(prop_name);
		data << vect_data ;
		dev_def_prop.push_back(data);
		add_wiz_dev_prop(prop_name, prop_desc,  prop_def);
	}
	else
		add_wiz_dev_prop(prop_name, prop_desc);

	prop_name = "PortNumber";
	prop_desc = "TCP Port Number.";
	prop_def  = """\n";
	vect_data.clear();
	vect_data.push_back("""");
	if (prop_def.length()>0)
	{
		Tango::DbDatum	data(prop_name);
		data << vect_data ;
		dev_def_prop.push_back(data);
		add_wiz_dev_prop(prop_name, prop_desc,  prop_def);
	}
	else
		add_wiz_dev_prop(prop_name, prop_desc);

	prop_name = "DeviceAddress";
	prop_desc = "Address of device (adjusted at hardware)";
	prop_def  = "1\n";
	vect_data.clear();
	vect_data.push_back("1");
	if (prop_def.length()>0)
	{
		Tango::DbDatum	data(prop_name);
		data << vect_data ;
		dev_def_prop.push_back(data);
		add_wiz_dev_prop(prop_name, prop_desc,  prop_def);
	}
	else
		add_wiz_dev_prop(prop_name, prop_desc);

	prop_name = "SimulationMode";
	prop_desc = "";
	prop_def  = "1\n";
	vect_data.clear();
	vect_data.push_back("1");
	if (prop_def.length()>0)
	{
		Tango::DbDatum	data(prop_name);
		data << vect_data ;
		dev_def_prop.push_back(data);
		add_wiz_dev_prop(prop_name, prop_desc,  prop_def);
	}
	else
		add_wiz_dev_prop(prop_name, prop_desc);

	prop_name = "LogicOps";
	prop_desc = "true, if the hardware supports logical operations";
	prop_def  = "false\n";
	vect_data.clear();
	vect_data.push_back("false");
	if (prop_def.length()>0)
	{
		Tango::DbDatum	data(prop_name);
		data << vect_data ;
		dev_def_prop.push_back(data);
		add_wiz_dev_prop(prop_name, prop_desc,  prop_def);
	}
	else
		add_wiz_dev_prop(prop_name, prop_desc);

	prop_name = "ConnectType";
	prop_desc = "connection type, either `serial` or `net`";
	prop_def  = """\n";
	vect_data.clear();
	vect_data.push_back("""");
	if (prop_def.length()>0)
	{
		Tango::DbDatum	data(prop_name);
		data << vect_data ;
		dev_def_prop.push_back(data);
		add_wiz_dev_prop(prop_name, prop_desc,  prop_def);
	}
	else
		add_wiz_dev_prop(prop_name, prop_desc);

	prop_name = "DeviceFile";
	prop_desc = "tty device file name";
	prop_def  = """\n";
	vect_data.clear();
	vect_data.push_back("""");
	if (prop_def.length()>0)
	{
		Tango::DbDatum	data(prop_name);
		data << vect_data ;
		dev_def_prop.push_back(data);
		add_wiz_dev_prop(prop_name, prop_desc,  prop_def);
	}
	else
		add_wiz_dev_prop(prop_name, prop_desc);

	prop_name = "BaudRate";
	prop_desc = "tty device baud rate";
	prop_def  = "0\n";
	vect_data.clear();
	vect_data.push_back("0");
	if (prop_def.length()>0)
	{
		Tango::DbDatum	data(prop_name);
		data << vect_data ;
		dev_def_prop.push_back(data);
		add_wiz_dev_prop(prop_name, prop_desc,  prop_def);
	}
	else
		add_wiz_dev_prop(prop_name, prop_desc);
}


//--------------------------------------------------------
/**
 *	Method      : Eurotherm2408::Eurotherm2408Class::write_class_property()
 *	Description : Set class description fields as property in database
 */
//--------------------------------------------------------
void Eurotherm2408Class::write_class_property()
{
	//	First time, check if database used
	if (Tango::Util::_UseDb == false)
		return;

	Tango::DbData	data;
	string	classname = get_name();
	string	header;
	string::size_type	start, end;

	//	Put title
	Tango::DbDatum	title("ProjectTitle");
	string	str_title("Eurotherm2408");
	title << str_title;
	data.push_back(title);

	//	Put Description
	Tango::DbDatum	description("Description");
	vector<string>	str_desc;
	str_desc.push_back("");
	description << str_desc;
	data.push_back(description);
		
	//	put cvs or svn location
	string	filename("Eurotherm2408");
	filename += "Class.cpp";
	
	// check for cvs information
	string	src_path(CvsPath);
	start = src_path.find("/");
	if (start!=string::npos)
	{
		end   = src_path.find(filename);
		if (end>start)
		{
			string	strloc = src_path.substr(start, end-start);
			//	Check if specific repository
			start = strloc.find("/cvsroot/");
			if (start!=string::npos && start>0)
			{
				string	repository = strloc.substr(0, start);
				if (repository.find("/segfs/")!=string::npos)
					strloc = "ESRF:" + strloc.substr(start, strloc.length()-start);
			}
			Tango::DbDatum	cvs_loc("cvs_location");
			cvs_loc << strloc;
			data.push_back(cvs_loc);
		}
	}
	// check for svn information
	else
	{
		string	src_path(SvnPath);
		start = src_path.find("://");
		if (start!=string::npos)
		{
			end = src_path.find(filename);
			if (end>start)
			{
				header = "$HeadURL: ";
				start = header.length();
				string	strloc = src_path.substr(start, (end-start));
				
				Tango::DbDatum	svn_loc("svn_location");
				svn_loc << strloc;
				data.push_back(svn_loc);
			}
		}
	}

	//	Get CVS or SVN revision tag
	
	// CVS tag
	string	tagname(TagName);
	header = "$Name: ";
	start = header.length();
	string	endstr(" $");
	
	end   = tagname.find(endstr);
	if (end!=string::npos && end>start)
	{
		string	strtag = tagname.substr(start, end-start);
		Tango::DbDatum	cvs_tag("cvs_tag");
		cvs_tag << strtag;
		data.push_back(cvs_tag);
	}
	
	// SVN tag
	string	svnpath(SvnPath);
	header = "$HeadURL: ";
	start = header.length();
	
	end   = svnpath.find(endstr);
	if (end!=string::npos && end>start)
	{
		string	strloc = svnpath.substr(start, end-start);
		
		string tagstr ("/tags/");
		start = strloc.find(tagstr);
		if ( start!=string::npos )
		{
			start = start + tagstr.length();
			end   = strloc.find(filename);
			string	strtag = strloc.substr(start, end-start-1);
			
			Tango::DbDatum	svn_tag("svn_tag");
			svn_tag << strtag;
			data.push_back(svn_tag);
		}
	}

	//	Get URL location
	string	httpServ(HttpServer);
	if (httpServ.length()>0)
	{
		Tango::DbDatum	db_doc_url("doc_url");
		db_doc_url << httpServ;
		data.push_back(db_doc_url);
	}

	//  Put inheritance
	Tango::DbDatum	inher_datum("InheritedFrom");
	vector<string> inheritance;
	inheritance.push_back("Device_4Impl");
	inher_datum << inheritance;
	data.push_back(inher_datum);

	//	Call database and and values
	get_db_class()->put_property(data);
}




//===================================================================
//	Factory methods
//===================================================================


//--------------------------------------------------------
/**
 * method : 		Eurotherm2408Class::device_factory
 * description : 	Create the device object(s)
 *                  and store them in the device list
 *
 * @param	*devlist_ptr	The device name list
 */
//--------------------------------------------------------
void Eurotherm2408Class::device_factory(const Tango::DevVarStringArray *devlist_ptr)
{

	/*----- PROTECTED REGION ID(Eurotherm2408::Class::device_factory_before) ENABLED START -----*/

	//	Add your own code
	

	/*----- PROTECTED REGION END -----*/	//	Eurotherm2408::Class::device_factory_before

	//	Create devices and add it into the device list
	for (unsigned long i=0 ; i<devlist_ptr->length() ; i++)
	{
		cout4 << "Device name : " << (*devlist_ptr)[i].in() << endl;
		device_list.push_back(new Eurotherm2408(this, (*devlist_ptr)[i]));							 
	}

	//	Manage dynamic attributes if any
	erase_dynamic_attributes(devlist_ptr, get_class_attr()->get_attr_list());

	//	Export devices to the outside world
	for (unsigned long i=1 ; i<=devlist_ptr->length() ; i++)
	{
		//	Add dynamic attributes if any
		Eurotherm2408 *dev = static_cast<Eurotherm2408 *>(device_list[device_list.size()-i]);
		dev->add_dynamic_attributes();

		//	Check before if database used.
		if ((Tango::Util::_UseDb == true) && (Tango::Util::_FileDb == false))
			export_device(dev);
		else
			export_device(dev, dev->get_name().c_str());
	}

	/*----- PROTECTED REGION ID(Eurotherm2408::Class::device_factory_after) ENABLED START -----*/

	//	Add your own code
	

	/*----- PROTECTED REGION END -----*/	//	Eurotherm2408::Class::device_factory_after

	
}


//--------------------------------------------------------
/**
 *	Method      : Eurotherm2408::Eurotherm2408Class::attribute_factory()
 *	Description : Create the attribute object(s)
 *	              and store them in the attribute list
 */
//--------------------------------------------------------
void Eurotherm2408Class::attribute_factory(vector<Tango::Attr *> &att_list)
{
	/*----- PROTECTED REGION ID(Eurotherm2408::Class::attribute_factory_before) ENABLED START -----*/

	//	Add your own code

	/*----- PROTECTED REGION END -----*/	//	Eurotherm2408::Class::attribute_factory_before


	//	Attribute : Temperature
	TemperatureAttrib	*temperature = new TemperatureAttrib();
	Tango::UserDefaultAttrProp	temperature_prop;
	temperature_prop.set_description("The current temperature");
	temperature_prop.set_label("Temperature");
	temperature_prop.set_unit("C");
	temperature_prop.set_standard_unit("C");
	temperature_prop.set_display_unit("C");
	temperature_prop.set_format("%4.1f");
	//	max_value	not set for	Temperature
	//	min_value	not set for	Temperature
	//	max_alarm	not set for	Temperature
	//	min_alarm	not set for	Temperature
	//	max_warning	not set for	Temperature
	//	min_warning	not set for	Temperature
	//	delta_t	not set for	Temperature
	//	delta_val	not set for	Temperature
	temperature->set_default_properties(temperature_prop);
	//	Not Polled
	temperature->set_disp_level(Tango::OPERATOR);
	//	Not memorized

	//	Temperature does not fire change event
	//	Temperature does not fire archive event
	//	Temperature does not fire data_ready event
	att_list.push_back(temperature);

	//	Attribute : Setpoint
	SetpointAttrib	*setpoint = new SetpointAttrib();
	Tango::UserDefaultAttrProp	setpoint_prop;
	setpoint_prop.set_description("The current temperature setpoint");
	setpoint_prop.set_label("Setpoint");
	setpoint_prop.set_unit("C");
	setpoint_prop.set_standard_unit("C");
	setpoint_prop.set_display_unit("C");
	setpoint_prop.set_format("%4.1f");
	//	max_value	not set for	Setpoint
	//	min_value	not set for	Setpoint
	//	max_alarm	not set for	Setpoint
	//	min_alarm	not set for	Setpoint
	//	max_warning	not set for	Setpoint
	//	min_warning	not set for	Setpoint
	//	delta_t	not set for	Setpoint
	//	delta_val	not set for	Setpoint
	setpoint->set_default_properties(setpoint_prop);
	//	Not Polled
	setpoint->set_disp_level(Tango::OPERATOR);
	//	Not memorized

	//	Setpoint does not fire change event
	//	Setpoint does not fire archive event
	//	Setpoint does not fire data_ready event
	att_list.push_back(setpoint);

	//	Attribute : Manual
	ManualAttrib	*manual = new ManualAttrib();
	Tango::UserDefaultAttrProp	manual_prop;
	manual_prop.set_description("Manual mode (true = on, false = off)");
	//	label	not set for	Manual
	//	unit	not set for	Manual
	//	standard_unit	not set for	Manual
	//	display_unit	not set for	Manual
	//	format	not set for	Manual
	//	max_value	not set for	Manual
	//	min_value	not set for	Manual
	//	max_alarm	not set for	Manual
	//	min_alarm	not set for	Manual
	//	max_warning	not set for	Manual
	//	min_warning	not set for	Manual
	//	delta_t	not set for	Manual
	//	delta_val	not set for	Manual
	manual->set_default_properties(manual_prop);
	//	Not Polled
	manual->set_disp_level(Tango::EXPERT);
	//	Not memorized

	//	Manual does not fire change event
	//	Manual does not fire archive event
	//	Manual does not fire data_ready event
	att_list.push_back(manual);

	//	Attribute : ProgramState
	ProgramStateAttrib	*programstate = new ProgramStateAttrib();
	Tango::UserDefaultAttrProp	programstate_prop;
	programstate_prop.set_description("Program state. Possible values:\n\nreset / run / hold /  complete");
	//	label	not set for	ProgramState
	//	unit	not set for	ProgramState
	//	standard_unit	not set for	ProgramState
	//	display_unit	not set for	ProgramState
	//	format	not set for	ProgramState
	//	max_value	not set for	ProgramState
	//	min_value	not set for	ProgramState
	//	max_alarm	not set for	ProgramState
	//	min_alarm	not set for	ProgramState
	//	max_warning	not set for	ProgramState
	//	min_warning	not set for	ProgramState
	//	delta_t	not set for	ProgramState
	//	delta_val	not set for	ProgramState
	programstate->set_default_properties(programstate_prop);
	//	Not Polled
	programstate->set_disp_level(Tango::OPERATOR);
	//	Not memorized

	//	ProgramState does not fire change event
	//	ProgramState does not fire archive event
	//	ProgramState does not fire data_ready event
	att_list.push_back(programstate);

	//	Attribute : CurrentProgram
	CurrentProgramAttrib	*currentprogram = new CurrentProgramAttrib();
	Tango::UserDefaultAttrProp	currentprogram_prop;
	currentprogram_prop.set_description("Number of the currently running program.");
	//	label	not set for	CurrentProgram
	currentprogram_prop.set_unit("""");
	currentprogram_prop.set_standard_unit("""");
	currentprogram_prop.set_display_unit("""");
	//	format	not set for	CurrentProgram
	//	max_value	not set for	CurrentProgram
	//	min_value	not set for	CurrentProgram
	//	max_alarm	not set for	CurrentProgram
	//	min_alarm	not set for	CurrentProgram
	//	max_warning	not set for	CurrentProgram
	//	min_warning	not set for	CurrentProgram
	//	delta_t	not set for	CurrentProgram
	//	delta_val	not set for	CurrentProgram
	currentprogram->set_default_properties(currentprogram_prop);
	//	Not Polled
	currentprogram->set_disp_level(Tango::OPERATOR);
	//	Not memorized

	//	CurrentProgram does not fire change event
	//	CurrentProgram does not fire archive event
	//	CurrentProgram does not fire data_ready event
	att_list.push_back(currentprogram);

	//	Attribute : CurrentSegment
	CurrentSegmentAttrib	*currentsegment = new CurrentSegmentAttrib();
	Tango::UserDefaultAttrProp	currentsegment_prop;
	currentsegment_prop.set_description("Number of the currently running segment.");
	//	label	not set for	CurrentSegment
	currentsegment_prop.set_unit("""");
	currentsegment_prop.set_standard_unit("""");
	currentsegment_prop.set_display_unit("""");
	//	format	not set for	CurrentSegment
	//	max_value	not set for	CurrentSegment
	//	min_value	not set for	CurrentSegment
	//	max_alarm	not set for	CurrentSegment
	//	min_alarm	not set for	CurrentSegment
	//	max_warning	not set for	CurrentSegment
	//	min_warning	not set for	CurrentSegment
	//	delta_t	not set for	CurrentSegment
	//	delta_val	not set for	CurrentSegment
	currentsegment->set_default_properties(currentsegment_prop);
	//	Not Polled
	currentsegment->set_disp_level(Tango::OPERATOR);
	//	Not memorized

	//	CurrentSegment does not fire change event
	//	CurrentSegment does not fire archive event
	//	CurrentSegment does not fire data_ready event
	att_list.push_back(currentsegment);

	//	Attribute : RemainingProgramTime
	RemainingProgramTimeAttrib	*remainingprogramtime = new RemainingProgramTimeAttrib();
	Tango::UserDefaultAttrProp	remainingprogramtime_prop;
	remainingprogramtime_prop.set_description("Remaining program time in hours");
	//	label	not set for	RemainingProgramTime
	remainingprogramtime_prop.set_unit("h");
	remainingprogramtime_prop.set_standard_unit("h");
	remainingprogramtime_prop.set_display_unit("h");
	//	format	not set for	RemainingProgramTime
	//	max_value	not set for	RemainingProgramTime
	//	min_value	not set for	RemainingProgramTime
	//	max_alarm	not set for	RemainingProgramTime
	//	min_alarm	not set for	RemainingProgramTime
	//	max_warning	not set for	RemainingProgramTime
	//	min_warning	not set for	RemainingProgramTime
	//	delta_t	not set for	RemainingProgramTime
	//	delta_val	not set for	RemainingProgramTime
	remainingprogramtime->set_default_properties(remainingprogramtime_prop);
	//	Not Polled
	remainingprogramtime->set_disp_level(Tango::OPERATOR);
	//	Not memorized

	//	RemainingProgramTime does not fire change event
	//	RemainingProgramTime does not fire archive event
	//	RemainingProgramTime does not fire data_ready event
	att_list.push_back(remainingprogramtime);

	//	Attribute : RemainingSegmentTime
	RemainingSegmentTimeAttrib	*remainingsegmenttime = new RemainingSegmentTimeAttrib();
	Tango::UserDefaultAttrProp	remainingsegmenttime_prop;
	remainingsegmenttime_prop.set_description("Remaining segment time in seconds");
	//	label	not set for	RemainingSegmentTime
	remainingsegmenttime_prop.set_unit("s");
	remainingsegmenttime_prop.set_standard_unit("s");
	remainingsegmenttime_prop.set_display_unit("s");
	//	format	not set for	RemainingSegmentTime
	//	max_value	not set for	RemainingSegmentTime
	//	min_value	not set for	RemainingSegmentTime
	//	max_alarm	not set for	RemainingSegmentTime
	//	min_alarm	not set for	RemainingSegmentTime
	//	max_warning	not set for	RemainingSegmentTime
	//	min_warning	not set for	RemainingSegmentTime
	//	delta_t	not set for	RemainingSegmentTime
	//	delta_val	not set for	RemainingSegmentTime
	remainingsegmenttime->set_default_properties(remainingsegmenttime_prop);
	//	Not Polled
	remainingsegmenttime->set_disp_level(Tango::OPERATOR);
	//	Not memorized

	//	RemainingSegmentTime does not fire change event
	//	RemainingSegmentTime does not fire archive event
	//	RemainingSegmentTime does not fire data_ready event
	att_list.push_back(remainingsegmenttime);

	//	Attribute : SegmentType
	SegmentTypeAttrib	*segmenttype = new SegmentTypeAttrib();
	Tango::UserDefaultAttrProp	segmenttype_prop;
	segmenttype_prop.set_description("The type of segment currently running.");
	//	label	not set for	SegmentType
	//	unit	not set for	SegmentType
	//	standard_unit	not set for	SegmentType
	//	display_unit	not set for	SegmentType
	//	format	not set for	SegmentType
	//	max_value	not set for	SegmentType
	//	min_value	not set for	SegmentType
	//	max_alarm	not set for	SegmentType
	//	min_alarm	not set for	SegmentType
	//	max_warning	not set for	SegmentType
	//	min_warning	not set for	SegmentType
	//	delta_t	not set for	SegmentType
	//	delta_val	not set for	SegmentType
	segmenttype->set_default_properties(segmenttype_prop);
	//	Not Polled
	segmenttype->set_disp_level(Tango::OPERATOR);
	//	Not memorized

	//	SegmentType does not fire change event
	//	SegmentType does not fire archive event
	//	SegmentType does not fire data_ready event
	att_list.push_back(segmenttype);

	//	Attribute : ProgramDir
	ProgramDirAttrib	*programdir = new ProgramDirAttrib();
	Tango::UserDefaultAttrProp	programdir_prop;
	programdir_prop.set_description("Path to directory containing controller programs");
	//	label	not set for	ProgramDir
	//	unit	not set for	ProgramDir
	//	standard_unit	not set for	ProgramDir
	//	display_unit	not set for	ProgramDir
	//	format	not set for	ProgramDir
	//	max_value	not set for	ProgramDir
	//	min_value	not set for	ProgramDir
	//	max_alarm	not set for	ProgramDir
	//	min_alarm	not set for	ProgramDir
	//	max_warning	not set for	ProgramDir
	//	min_warning	not set for	ProgramDir
	//	delta_t	not set for	ProgramDir
	//	delta_val	not set for	ProgramDir
	programdir->set_default_properties(programdir_prop);
	//	Not Polled
	programdir->set_disp_level(Tango::OPERATOR);
	programdir->set_memorized();
	programdir->set_memorized_init(true);
	//	ProgramDir does not fire change event
	//	ProgramDir does not fire archive event
	//	ProgramDir does not fire data_ready event
	att_list.push_back(programdir);

	//	Attribute : MaxPrograms
	MaxProgramsAttrib	*maxprograms = new MaxProgramsAttrib();
	Tango::UserDefaultAttrProp	maxprograms_prop;
	maxprograms_prop.set_description("Maximum number of programs this controller can store.");
	//	label	not set for	MaxPrograms
	//	unit	not set for	MaxPrograms
	//	standard_unit	not set for	MaxPrograms
	//	display_unit	not set for	MaxPrograms
	maxprograms_prop.set_format("%2.2f");
	//	max_value	not set for	MaxPrograms
	//	min_value	not set for	MaxPrograms
	//	max_alarm	not set for	MaxPrograms
	//	min_alarm	not set for	MaxPrograms
	//	max_warning	not set for	MaxPrograms
	//	min_warning	not set for	MaxPrograms
	//	delta_t	not set for	MaxPrograms
	//	delta_val	not set for	MaxPrograms
	maxprograms->set_default_properties(maxprograms_prop);
	//	Not Polled
	maxprograms->set_disp_level(Tango::OPERATOR);
	//	Not memorized

	//	MaxPrograms does not fire change event
	//	MaxPrograms does not fire archive event
	//	MaxPrograms does not fire data_ready event
	att_list.push_back(maxprograms);

	//	Attribute : AllowedStates
	AllowedStatesAttrib	*allowedstates = new AllowedStatesAttrib();
	Tango::UserDefaultAttrProp	allowedstates_prop;
	allowedstates_prop.set_description("Bitmask to set which bits of the controller status byte should\nnot set the device state to ALARM.\nThe status byte bit meaning is:\n\n0: ALARM1\n1: ALARM2\n2: ALARM3\n3: ALARM4\n4: MANUAL MODE\n5: SENSOR FAILURE\n6: LOOP BREAK\n7: HEATER FAILURE\n\nSo to e.g. not cause an alarm state on ALARM1 and MANUAL MODE set the\nattribute to 17 ( = binary 00010001, bits 0 and 4 => 1).");
	//	label	not set for	AllowedStates
	//	unit	not set for	AllowedStates
	//	standard_unit	not set for	AllowedStates
	//	display_unit	not set for	AllowedStates
	allowedstates_prop.set_format("%2.3f");
	//	max_value	not set for	AllowedStates
	//	min_value	not set for	AllowedStates
	//	max_alarm	not set for	AllowedStates
	//	min_alarm	not set for	AllowedStates
	//	max_warning	not set for	AllowedStates
	//	min_warning	not set for	AllowedStates
	//	delta_t	not set for	AllowedStates
	//	delta_val	not set for	AllowedStates
	allowedstates->set_default_properties(allowedstates_prop);
	//	Not Polled
	allowedstates->set_disp_level(Tango::EXPERT);
	allowedstates->set_memorized();
	allowedstates->set_memorized_init(true);
	//	AllowedStates does not fire change event
	//	AllowedStates does not fire archive event
	//	AllowedStates does not fire data_ready event
	att_list.push_back(allowedstates);

	//	Attribute : HoldBack
	HoldBackAttrib	*holdback = new HoldBackAttrib();
	Tango::UserDefaultAttrProp	holdback_prop;
	holdback_prop.set_description("Report / set holdback state.\n true = holdback enabled\nfalse = holdback disabled ");
	//	label	not set for	HoldBack
	//	unit	not set for	HoldBack
	//	standard_unit	not set for	HoldBack
	//	display_unit	not set for	HoldBack
	//	format	not set for	HoldBack
	//	max_value	not set for	HoldBack
	//	min_value	not set for	HoldBack
	//	max_alarm	not set for	HoldBack
	//	min_alarm	not set for	HoldBack
	//	max_warning	not set for	HoldBack
	//	min_warning	not set for	HoldBack
	//	delta_t	not set for	HoldBack
	//	delta_val	not set for	HoldBack
	holdback->set_default_properties(holdback_prop);
	//	Not Polled
	holdback->set_disp_level(Tango::EXPERT);
	holdback->set_memorized();
	holdback->set_memorized_init(true);
	//	HoldBack does not fire change event
	//	HoldBack does not fire archive event
	//	HoldBack does not fire data_ready event
	att_list.push_back(holdback);

	//	Attribute : OutputLevel
	OutputLevelAttrib	*outputlevel = new OutputLevelAttrib();
	Tango::UserDefaultAttrProp	outputlevel_prop;
	//	description	not set for	OutputLevel
	//	label	not set for	OutputLevel
	outputlevel_prop.set_unit("%");
	outputlevel_prop.set_standard_unit("%");
	outputlevel_prop.set_display_unit("%");
	outputlevel_prop.set_format("%5.2f");
	//	max_value	not set for	OutputLevel
	//	min_value	not set for	OutputLevel
	//	max_alarm	not set for	OutputLevel
	//	min_alarm	not set for	OutputLevel
	//	max_warning	not set for	OutputLevel
	//	min_warning	not set for	OutputLevel
	//	delta_t	not set for	OutputLevel
	//	delta_val	not set for	OutputLevel
	outputlevel->set_default_properties(outputlevel_prop);
	//	Not Polled
	outputlevel->set_disp_level(Tango::OPERATOR);
	//	Not memorized

	//	OutputLevel does not fire change event
	//	OutputLevel does not fire archive event
	//	OutputLevel does not fire data_ready event
	att_list.push_back(outputlevel);

	//	Attribute : OutputLevelMax
	OutputLevelMaxAttrib	*outputlevelmax = new OutputLevelMaxAttrib();
	Tango::UserDefaultAttrProp	outputlevelmax_prop;
	//	description	not set for	OutputLevelMax
	//	label	not set for	OutputLevelMax
	outputlevelmax_prop.set_unit("%");
	outputlevelmax_prop.set_standard_unit("%");
	outputlevelmax_prop.set_display_unit("%");
	outputlevelmax_prop.set_format("%5.2f");
	//	max_value	not set for	OutputLevelMax
	//	min_value	not set for	OutputLevelMax
	//	max_alarm	not set for	OutputLevelMax
	//	min_alarm	not set for	OutputLevelMax
	//	max_warning	not set for	OutputLevelMax
	//	min_warning	not set for	OutputLevelMax
	//	delta_t	not set for	OutputLevelMax
	//	delta_val	not set for	OutputLevelMax
	outputlevelmax->set_default_properties(outputlevelmax_prop);
	//	Not Polled
	outputlevelmax->set_disp_level(Tango::EXPERT);
	//	Not memorized

	//	OutputLevelMax does not fire change event
	//	OutputLevelMax does not fire archive event
	//	OutputLevelMax does not fire data_ready event
	att_list.push_back(outputlevelmax);

	//	Attribute : OutputLevelMin
	OutputLevelMinAttrib	*outputlevelmin = new OutputLevelMinAttrib();
	Tango::UserDefaultAttrProp	outputlevelmin_prop;
	//	description	not set for	OutputLevelMin
	//	label	not set for	OutputLevelMin
	outputlevelmin_prop.set_unit("%");
	outputlevelmin_prop.set_standard_unit("%");
	outputlevelmin_prop.set_display_unit("%");
	outputlevelmin_prop.set_format("%5.2f");
	//	max_value	not set for	OutputLevelMin
	//	min_value	not set for	OutputLevelMin
	//	max_alarm	not set for	OutputLevelMin
	//	min_alarm	not set for	OutputLevelMin
	//	max_warning	not set for	OutputLevelMin
	//	min_warning	not set for	OutputLevelMin
	//	delta_t	not set for	OutputLevelMin
	//	delta_val	not set for	OutputLevelMin
	outputlevelmin->set_default_properties(outputlevelmin_prop);
	//	Not Polled
	outputlevelmin->set_disp_level(Tango::EXPERT);
	//	Not memorized

	//	OutputLevelMin does not fire change event
	//	OutputLevelMin does not fire archive event
	//	OutputLevelMin does not fire data_ready event
	att_list.push_back(outputlevelmin);


	//	Create a list of static attributes
	create_static_attribute_list(get_class_attr()->get_attr_list());

	/*----- PROTECTED REGION ID(Eurotherm2408::Class::attribute_factory_after) ENABLED START -----*/

	//	Add your own code

	/*----- PROTECTED REGION END -----*/	//	Eurotherm2408::Class::attribute_factory_after

}


//--------------------------------------------------------
/**
 *	Method      : Eurotherm2408::Eurotherm2408Class::command_factory()
 *	Description : Create the command object(s)
 *	              and store them in the command list
 */
//--------------------------------------------------------
void Eurotherm2408Class::command_factory()
{
	/*----- PROTECTED REGION ID(Eurotherm2408::Class::command_factory_before) ENABLED START -----*/

	/*----- PROTECTED REGION END -----*/	//	Eurotherm2408::Class::command_factory_before

	StartProgramClass	*pStartProgramCmd =
		new StartProgramClass("StartProgram",
			Tango::DEV_USHORT, Tango::DEV_VOID,
			"program number",
			"",
			Tango::OPERATOR);
	command_list.push_back(pStartProgramCmd);
	StopProgramClass	*pStopProgramCmd =
		new StopProgramClass("StopProgram",
			Tango::DEV_VOID, Tango::DEV_VOID,
			"",
			"",
			Tango::OPERATOR);
	command_list.push_back(pStopProgramCmd);
	HoldProgramClass	*pHoldProgramCmd =
		new HoldProgramClass("HoldProgram",
			Tango::DEV_VOID, Tango::DEV_VOID,
			"",
			"",
			Tango::OPERATOR);
	command_list.push_back(pHoldProgramCmd);
	LoadProgramClass	*pLoadProgramCmd =
		new LoadProgramClass("LoadProgram",
			Tango::DEV_STRING, Tango::DEV_VOID,
			"path to program file, either absolute or relative to attribute ProgramDir",
			"",
			Tango::OPERATOR);
	command_list.push_back(pLoadProgramCmd);
	DeleteProgramClass	*pDeleteProgramCmd =
		new DeleteProgramClass("DeleteProgram",
			Tango::DEV_USHORT, Tango::DEV_VOID,
			"Program number",
			"",
			Tango::OPERATOR);
	command_list.push_back(pDeleteProgramCmd);

	/*----- PROTECTED REGION ID(Eurotherm2408::Class::command_factory_after) ENABLED START -----*/

	/*----- PROTECTED REGION END -----*/	//	Eurotherm2408::Class::command_factory_after

}




//===================================================================
//	Dynamic attributes related methods
//===================================================================


//--------------------------------------------------------
/**
 * method : 		Eurotherm2408Class::create_static_attribute_list
 * description : 	Create the a list of static attributes
 *
 * @param	att_list	the ceated attribute list 
 */
//--------------------------------------------------------
void Eurotherm2408Class::create_static_attribute_list(vector<Tango::Attr *> &att_list)
{
	for (unsigned long i=0 ; i<att_list.size() ; i++)
	{
		string att_name(att_list[i]->get_name());
		transform(att_name.begin(), att_name.end(), att_name.begin(), ::tolower);
		defaultAttList.push_back(att_name);
	}

	cout2 << defaultAttList.size() << " attributes in default list" << endl;


	/*----- PROTECTED REGION ID(Eurotherm2408::Class::create_static_att_list) ENABLED START -----*/

	/*----- PROTECTED REGION END -----*/	//	Eurotherm2408::Class::create_static_att_list

}


//--------------------------------------------------------
/**
 * method : 		Eurotherm2408Class::erase_dynamic_attributes
 * description : 	delete the dynamic attributes if any.
 *
 * @param	devlist_ptr	the device list pointer
 * @param	list of all attributes
 */
//--------------------------------------------------------
void Eurotherm2408Class::erase_dynamic_attributes(const Tango::DevVarStringArray *devlist_ptr, vector<Tango::Attr *> &att_list)
{
	Tango::Util *tg = Tango::Util::instance();

	for (unsigned long i=0 ; i<devlist_ptr->length() ; i++)
	{	
		Tango::DeviceImpl *dev_impl = tg->get_device_by_name(((string)(*devlist_ptr)[i]).c_str());
		Eurotherm2408 *dev = static_cast<Eurotherm2408 *> (dev_impl);
		
		vector<Tango::Attribute *> &dev_att_list = dev->get_device_attr()->get_attribute_list();
		vector<Tango::Attribute *>::iterator ite_att;
		for (ite_att=dev_att_list.begin() ; ite_att != dev_att_list.end() ; ++ite_att)
		{
			string att_name((*ite_att)->get_name_lower());
			if ((att_name == "state") || (att_name == "status"))
				continue;
			vector<string>::iterator ite_str = find(defaultAttList.begin(), defaultAttList.end(), att_name);
			if (ite_str == defaultAttList.end())
			{
				cout2 << att_name << " is a UNWANTED dynamic attribute for device " << (*devlist_ptr)[i] << endl;
				Tango::Attribute &att = dev->get_device_attr()->get_attr_by_name(att_name.c_str());
				dev->remove_attribute(att_list[att.get_attr_idx()],true);
				--ite_att;
			}
		}
	}
	/*----- PROTECTED REGION ID(Eurotherm2408::Class::erase_dynamic_attributes) ENABLED START -----*/

	/*----- PROTECTED REGION END -----*/	//	Eurotherm2408::Class::erase_dynamic_attributes

}



	/*----- PROTECTED REGION ID(Eurotherm2408::Class::Additional Methods) ENABLED START -----*/

	/*----- PROTECTED REGION END -----*/	//	Eurotherm2408::Class::Additional Methods

} //	namespace
