/*----- PROTECTED REGION ID(Eurotherm2408Class.h) ENABLED START -----*/
//=============================================================================
//
// file :        Eurotherm2408Class.h
//
// description : Include for the Eurotherm2408Class root class.
//               This class is the singleton class for.
//               the Eurotherm2408 device class..
//               It contains all properties and methods which the .
//               Eurotherm2408 requires only once e.g. the commands.
//
// project :     Eurotherm2408.
//
// $Author:  $
//
// $Revision:  $
// $Date:  $
//
// SVN only:
// $HeadURL:  $
//
// CVS only:
// $Source:  $
// $Log:  $
//
//=============================================================================
//                This file is generated by POGO
//        (Program Obviously used to Generate tango Object)
//=============================================================================


#ifndef EUROTHERM2408CLASS_H
#define EUROTHERM2408CLASS_H

#include <tango.h>
#include <Eurotherm2408.h>

/*----- PROTECTED REGION END -----*/

namespace Eurotherm2408_ns
{
	/*----- PROTECTED REGION ID(Eurotherm2408::classes for dynamic creation) ENABLED START -----*/

	/*----- PROTECTED REGION END -----*/	//	Eurotherm2408::classes for dynamic creation



//=========================================
//	Define classes for attributes
//=========================================
//	Attribute Temperature class definition
class TemperatureAttrib: public Tango::Attr
{
public:
	TemperatureAttrib():Attr("Temperature",
	                   Tango::DEV_DOUBLE, Tango::READ) {};
	~TemperatureAttrib() {};
	
	virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
		{(static_cast<Eurotherm2408 *>(dev))->read_Temperature(att);}
	virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
		{return (static_cast<Eurotherm2408 *>(dev))->is_Temperature_allowed(ty);}
};

//	Attribute Setpoint class definition
class SetpointAttrib: public Tango::Attr
{
public:
	SetpointAttrib():Attr("Setpoint",
	                   Tango::DEV_DOUBLE, Tango::READ_WRITE) {};
	~SetpointAttrib() {};
	
	virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
		{(static_cast<Eurotherm2408 *>(dev))->read_Setpoint(att);}
	virtual void write(Tango::DeviceImpl *dev,Tango::WAttribute &att)
		{(static_cast<Eurotherm2408 *>(dev))->write_Setpoint(att);}
	virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
		{return (static_cast<Eurotherm2408 *>(dev))->is_Setpoint_allowed(ty);}
};

//	Attribute Manual class definition
class ManualAttrib: public Tango::Attr
{
public:
	ManualAttrib():Attr("Manual",
	                   Tango::DEV_BOOLEAN, Tango::READ_WRITE) {};
	~ManualAttrib() {};
	
	virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
		{(static_cast<Eurotherm2408 *>(dev))->read_Manual(att);}
	virtual void write(Tango::DeviceImpl *dev,Tango::WAttribute &att)
		{(static_cast<Eurotherm2408 *>(dev))->write_Manual(att);}
	virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
		{return (static_cast<Eurotherm2408 *>(dev))->is_Manual_allowed(ty);}
};

//	Attribute ProgramState class definition
class ProgramStateAttrib: public Tango::Attr
{
public:
	ProgramStateAttrib():Attr("ProgramState",
	                   Tango::DEV_STRING, Tango::READ) {};
	~ProgramStateAttrib() {};
	
	virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
		{(static_cast<Eurotherm2408 *>(dev))->read_ProgramState(att);}
	virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
		{return (static_cast<Eurotherm2408 *>(dev))->is_ProgramState_allowed(ty);}
};

//	Attribute CurrentProgram class definition
class CurrentProgramAttrib: public Tango::Attr
{
public:
	CurrentProgramAttrib():Attr("CurrentProgram",
	                   Tango::DEV_USHORT, Tango::READ) {};
	~CurrentProgramAttrib() {};
	
	virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
		{(static_cast<Eurotherm2408 *>(dev))->read_CurrentProgram(att);}
	virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
		{return (static_cast<Eurotherm2408 *>(dev))->is_CurrentProgram_allowed(ty);}
};

//	Attribute CurrentSegment class definition
class CurrentSegmentAttrib: public Tango::Attr
{
public:
	CurrentSegmentAttrib():Attr("CurrentSegment",
	                   Tango::DEV_USHORT, Tango::READ) {};
	~CurrentSegmentAttrib() {};
	
	virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
		{(static_cast<Eurotherm2408 *>(dev))->read_CurrentSegment(att);}
	virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
		{return (static_cast<Eurotherm2408 *>(dev))->is_CurrentSegment_allowed(ty);}
};

//	Attribute RemainingProgramTime class definition
class RemainingProgramTimeAttrib: public Tango::Attr
{
public:
	RemainingProgramTimeAttrib():Attr("RemainingProgramTime",
	                   Tango::DEV_USHORT, Tango::READ) {};
	~RemainingProgramTimeAttrib() {};
	
	virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
		{(static_cast<Eurotherm2408 *>(dev))->read_RemainingProgramTime(att);}
	virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
		{return (static_cast<Eurotherm2408 *>(dev))->is_RemainingProgramTime_allowed(ty);}
};

//	Attribute RemainingSegmentTime class definition
class RemainingSegmentTimeAttrib: public Tango::Attr
{
public:
	RemainingSegmentTimeAttrib():Attr("RemainingSegmentTime",
	                   Tango::DEV_USHORT, Tango::READ) {};
	~RemainingSegmentTimeAttrib() {};
	
	virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
		{(static_cast<Eurotherm2408 *>(dev))->read_RemainingSegmentTime(att);}
	virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
		{return (static_cast<Eurotherm2408 *>(dev))->is_RemainingSegmentTime_allowed(ty);}
};

//	Attribute SegmentType class definition
class SegmentTypeAttrib: public Tango::Attr
{
public:
	SegmentTypeAttrib():Attr("SegmentType",
	                   Tango::DEV_STRING, Tango::READ) {};
	~SegmentTypeAttrib() {};
	
	virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
		{(static_cast<Eurotherm2408 *>(dev))->read_SegmentType(att);}
	virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
		{return (static_cast<Eurotherm2408 *>(dev))->is_SegmentType_allowed(ty);}
};

//	Attribute ProgramDir class definition
class ProgramDirAttrib: public Tango::Attr
{
public:
	ProgramDirAttrib():Attr("ProgramDir",
	                   Tango::DEV_STRING, Tango::READ_WRITE) {};
	~ProgramDirAttrib() {};
	
	virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
		{(static_cast<Eurotherm2408 *>(dev))->read_ProgramDir(att);}
	virtual void write(Tango::DeviceImpl *dev,Tango::WAttribute &att)
		{(static_cast<Eurotherm2408 *>(dev))->write_ProgramDir(att);}
	virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
		{return (static_cast<Eurotherm2408 *>(dev))->is_ProgramDir_allowed(ty);}
};

//	Attribute MaxPrograms class definition
class MaxProgramsAttrib: public Tango::Attr
{
public:
	MaxProgramsAttrib():Attr("MaxPrograms",
	                   Tango::DEV_USHORT, Tango::READ) {};
	~MaxProgramsAttrib() {};
	
	virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
		{(static_cast<Eurotherm2408 *>(dev))->read_MaxPrograms(att);}
	virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
		{return (static_cast<Eurotherm2408 *>(dev))->is_MaxPrograms_allowed(ty);}
};

//	Attribute AllowedStates class definition
class AllowedStatesAttrib: public Tango::Attr
{
public:
	AllowedStatesAttrib():Attr("AllowedStates",
	                   Tango::DEV_UCHAR, Tango::READ_WRITE) {};
	~AllowedStatesAttrib() {};
	
	virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
		{(static_cast<Eurotherm2408 *>(dev))->read_AllowedStates(att);}
	virtual void write(Tango::DeviceImpl *dev,Tango::WAttribute &att)
		{(static_cast<Eurotherm2408 *>(dev))->write_AllowedStates(att);}
	virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
		{return (static_cast<Eurotherm2408 *>(dev))->is_AllowedStates_allowed(ty);}
};

//	Attribute HoldBack class definition
class HoldBackAttrib: public Tango::Attr
{
public:
	HoldBackAttrib():Attr("HoldBack",
	                   Tango::DEV_BOOLEAN, Tango::READ_WRITE) {};
	~HoldBackAttrib() {};
	
	virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
		{(static_cast<Eurotherm2408 *>(dev))->read_HoldBack(att);}
	virtual void write(Tango::DeviceImpl *dev,Tango::WAttribute &att)
		{(static_cast<Eurotherm2408 *>(dev))->write_HoldBack(att);}
	virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
		{return (static_cast<Eurotherm2408 *>(dev))->is_HoldBack_allowed(ty);}
};

//	Attribute OutputLevel class definition
class OutputLevelAttrib: public Tango::Attr
{
public:
	OutputLevelAttrib():Attr("OutputLevel",
	                   Tango::DEV_DOUBLE, Tango::READ_WRITE) {};
	~OutputLevelAttrib() {};
	
	virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
		{(static_cast<Eurotherm2408 *>(dev))->read_OutputLevel(att);}
	virtual void write(Tango::DeviceImpl *dev,Tango::WAttribute &att)
		{(static_cast<Eurotherm2408 *>(dev))->write_OutputLevel(att);}
	virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
		{return (static_cast<Eurotherm2408 *>(dev))->is_OutputLevel_allowed(ty);}
};

//	Attribute OutputLevelMax class definition
class OutputLevelMaxAttrib: public Tango::Attr
{
public:
	OutputLevelMaxAttrib():Attr("OutputLevelMax",
	                   Tango::DEV_DOUBLE, Tango::READ_WRITE) {};
	~OutputLevelMaxAttrib() {};
	
	virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
		{(static_cast<Eurotherm2408 *>(dev))->read_OutputLevelMax(att);}
	virtual void write(Tango::DeviceImpl *dev,Tango::WAttribute &att)
		{(static_cast<Eurotherm2408 *>(dev))->write_OutputLevelMax(att);}
	virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
		{return (static_cast<Eurotherm2408 *>(dev))->is_OutputLevelMax_allowed(ty);}
};

//	Attribute OutputLevelMin class definition
class OutputLevelMinAttrib: public Tango::Attr
{
public:
	OutputLevelMinAttrib():Attr("OutputLevelMin",
	                   Tango::DEV_DOUBLE, Tango::READ_WRITE) {};
	~OutputLevelMinAttrib() {};
	
	virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
		{(static_cast<Eurotherm2408 *>(dev))->read_OutputLevelMin(att);}
	virtual void write(Tango::DeviceImpl *dev,Tango::WAttribute &att)
		{(static_cast<Eurotherm2408 *>(dev))->write_OutputLevelMin(att);}
	virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
		{return (static_cast<Eurotherm2408 *>(dev))->is_OutputLevelMin_allowed(ty);}
};





//=========================================
//	Define classes for commands
//=========================================
//	Command StartProgram class definition
class StartProgramClass : public Tango::Command
{
public:
	StartProgramClass(const char   *name,
	               Tango::CmdArgType in,
				   Tango::CmdArgType out,
				   const char        *in_desc,
				   const char        *out_desc,
				   Tango::DispLevel  level)
	:Command(name,in,out,in_desc,out_desc, level)	{};

	StartProgramClass(const char   *name,
	               Tango::CmdArgType in,
				   Tango::CmdArgType out)
	:Command(name,in,out)	{};
	~StartProgramClass() {};
	
	virtual CORBA::Any *execute (Tango::DeviceImpl *dev, const CORBA::Any &any);
	virtual bool is_allowed (Tango::DeviceImpl *dev, const CORBA::Any &any)
	{return (static_cast<Eurotherm2408 *>(dev))->is_StartProgram_allowed(any);}
};

//	Command StopProgram class definition
class StopProgramClass : public Tango::Command
{
public:
	StopProgramClass(const char   *name,
	               Tango::CmdArgType in,
				   Tango::CmdArgType out,
				   const char        *in_desc,
				   const char        *out_desc,
				   Tango::DispLevel  level)
	:Command(name,in,out,in_desc,out_desc, level)	{};

	StopProgramClass(const char   *name,
	               Tango::CmdArgType in,
				   Tango::CmdArgType out)
	:Command(name,in,out)	{};
	~StopProgramClass() {};
	
	virtual CORBA::Any *execute (Tango::DeviceImpl *dev, const CORBA::Any &any);
	virtual bool is_allowed (Tango::DeviceImpl *dev, const CORBA::Any &any)
	{return (static_cast<Eurotherm2408 *>(dev))->is_StopProgram_allowed(any);}
};

//	Command HoldProgram class definition
class HoldProgramClass : public Tango::Command
{
public:
	HoldProgramClass(const char   *name,
	               Tango::CmdArgType in,
				   Tango::CmdArgType out,
				   const char        *in_desc,
				   const char        *out_desc,
				   Tango::DispLevel  level)
	:Command(name,in,out,in_desc,out_desc, level)	{};

	HoldProgramClass(const char   *name,
	               Tango::CmdArgType in,
				   Tango::CmdArgType out)
	:Command(name,in,out)	{};
	~HoldProgramClass() {};
	
	virtual CORBA::Any *execute (Tango::DeviceImpl *dev, const CORBA::Any &any);
	virtual bool is_allowed (Tango::DeviceImpl *dev, const CORBA::Any &any)
	{return (static_cast<Eurotherm2408 *>(dev))->is_HoldProgram_allowed(any);}
};

//	Command LoadProgram class definition
class LoadProgramClass : public Tango::Command
{
public:
	LoadProgramClass(const char   *name,
	               Tango::CmdArgType in,
				   Tango::CmdArgType out,
				   const char        *in_desc,
				   const char        *out_desc,
				   Tango::DispLevel  level)
	:Command(name,in,out,in_desc,out_desc, level)	{};

	LoadProgramClass(const char   *name,
	               Tango::CmdArgType in,
				   Tango::CmdArgType out)
	:Command(name,in,out)	{};
	~LoadProgramClass() {};
	
	virtual CORBA::Any *execute (Tango::DeviceImpl *dev, const CORBA::Any &any);
	virtual bool is_allowed (Tango::DeviceImpl *dev, const CORBA::Any &any)
	{return (static_cast<Eurotherm2408 *>(dev))->is_LoadProgram_allowed(any);}
};

//	Command DeleteProgram class definition
class DeleteProgramClass : public Tango::Command
{
public:
	DeleteProgramClass(const char   *name,
	               Tango::CmdArgType in,
				   Tango::CmdArgType out,
				   const char        *in_desc,
				   const char        *out_desc,
				   Tango::DispLevel  level)
	:Command(name,in,out,in_desc,out_desc, level)	{};

	DeleteProgramClass(const char   *name,
	               Tango::CmdArgType in,
				   Tango::CmdArgType out)
	:Command(name,in,out)	{};
	~DeleteProgramClass() {};
	
	virtual CORBA::Any *execute (Tango::DeviceImpl *dev, const CORBA::Any &any);
	virtual bool is_allowed (Tango::DeviceImpl *dev, const CORBA::Any &any)
	{return (static_cast<Eurotherm2408 *>(dev))->is_DeleteProgram_allowed(any);}
};





/**
 *	The TemplateDevServClass singleton definition
 */

class
#ifdef _TG_WINDOWS_
	__declspec(dllexport)
#endif
	Eurotherm2408Class : public Tango::DeviceClass
{
	/*----- PROTECTED REGION ID(Eurotherm2408::Additionnal DServer data members) ENABLED START -----*/
public:
	

	/*----- PROTECTED REGION END -----*/	//	Eurotherm2408::Additionnal DServer data members



public:
//	write class properties data members
	Tango::DbData	cl_prop;
	Tango::DbData	cl_def_prop;
	Tango::DbData	dev_def_prop;

//	Method prototypes
	static Eurotherm2408Class *init(const char *);
	static Eurotherm2408Class *instance();
	~Eurotherm2408Class();
	Tango::DbDatum	get_class_property(string &);
	Tango::DbDatum	get_default_device_property(string &);
	Tango::DbDatum	get_default_class_property(string &);
	
protected:
	Eurotherm2408Class(string &);
	static Eurotherm2408Class *_instance;
	void command_factory();
	void attribute_factory(vector<Tango::Attr *> &);
	void write_class_property();
	void set_default_property();
	void get_class_property();
	string get_cvstag();
	string get_cvsroot();

private:
	void device_factory(const Tango::DevVarStringArray *);
	void create_static_attribute_list(vector<Tango::Attr *> &);
	void erase_dynamic_attributes(const Tango::DevVarStringArray *,vector<Tango::Attr *> &);
	vector<string>	defaultAttList;


};

}	//	namespace

#endif	//	EUROTHERM2408CLASS_H

