#include <iostream>
#include "ipc_usbdevice.h"
#include "ipc_exception.h"

/*!
	constructor for class USBDevice

	After successfull construction the object represents an
	opened usb device.


	- device :  the device file name

	Can throw:
		- IpcException
		
*/

USBDevice::USBDevice(const char *device)
	: dev(device)
{
	fd = device_open(dev.c_str());
}

USBDevice::~USBDevice()
{

}


int USBDevice::device_open(const char* device)
{
	if((fd = ::open(device, O_RDWR)) < 0)
    {
		throw IpcException(::strerror(errno),  __FILE__, __LINE__);
    }
	return fd;
}
