#ifndef IPC_USBDEVICE_H
#define IPC_USBDEVICE_H

#include <vector>
#include <string>
#include <sstream>
#include <cstring>

using namespace std;

extern "C"
{
	#include <unistd.h>
	#include <sys/types.h>
    #include <sys/stat.h>
    #include <fcntl.h>
	#include <errno.h>
	#include <termios.h>
}


class USBDevice 
{
	public:
		USBDevice(const char*);
		~USBDevice();

		/*!
 * 			returns usb device file name
 * 		*/
		const char* deviceName() {return dev.c_str();}
		/*!
 			returns file descriptor of established connection
		*/
		int	filedescriptor() {return fd;}

	private:
		int fd;
		string 	dev;
		int device_open(const char* device);
};

#endif
